unit OTFEFreeOTFE_frmSelectVolumeAndOffset;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Spin64,
  OTFEFreeOTFE_U;

type
  TfrmSelectVolumeFileAndOffset = class(TForm)
    lblFileDescSrc: TLabel;
    lblOffsetSrcBytes: TLabel;
    lblOffsetSrc: TLabel;
    edFilename: TEdit;
    se64Offset: TSpinEdit64;
    bbBrowsePartition: TBitBtn;
    bbBrowseFile: TBitBtn;
    pbOK: TButton;
    pbCancel: TButton;
    lblInstructions: TLabel;
    OpenDialog: TOpenDialog;
    procedure bbBrowseFileClick(Sender: TObject);
    procedure bbBrowsePartitionClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    OTFEFreeOTFE: TOTFEFreeOTFE;
    procedure SetDlgPurpose(encryptNotDecrypt: boolean);
    function Volume(): string;
    function Offset(): int64;
  end;


implementation

{$R *.dfm}

uses
  SDUGeneral;

procedure TfrmSelectVolumeFileAndOffset.SetDlgPurpose(encryptNotDecrypt: boolean);
begin
  if encryptNotDecrypt then
    begin
    self.Caption := 'Secure with PKCS#11 Secret Key';
    lblInstructions.caption := 'Please enter the volume/keyfile you wish to encrypt using the selected PKCS#11 secret key.';
    end
  else
    begin
    self.Caption := 'Remove PKCS#11 Secret Key Security';
    lblInstructions.caption := 'Please enter the volume/keyfile you wish to decrypt using the selected PKCS#11 secret key.';
    end;

end;

function TfrmSelectVolumeFileAndOffset.Volume(): string;
begin
  Result := edFilename.text;
end;

function TfrmSelectVolumeFileAndOffset.Offset(): int64;
begin
  Result := se64Offset.Value;
end;

procedure TfrmSelectVolumeFileAndOffset.bbBrowseFileClick(Sender: TObject);
begin
  OpenDialog.Filter     := FILE_FILTER_FLT_VOLUMESANDKEYFILES;
  OpenDialog.DefaultExt := FILE_FILTER_DFLT_VOLUMESANDKEYFILES;

  SDUOpenSaveDialogSetup(OpenDialog, edFilename.text);
  if OpenDialog.Execute() then
    begin
    edFilename.text := OpenDialog.Filename;
    end;

end;

procedure TfrmSelectVolumeFileAndOffset.bbBrowsePartitionClick(Sender: TObject);
var
  selectedPartition: string;
begin
  selectedPartition := OTFEFreeOTFE.SelectPartition();
  if (selectedPartition <> '') then
    begin
    edFilename.text := selectedPartition;
    end;

end;

procedure TfrmSelectVolumeFileAndOffset.FormShow(Sender: TObject);
begin
  edFilename.text := '';
end;

END.


