unit OTFEFreeOTFE_frmWizardChangePasswordCreateKeyfile;
// Description:
// By Sarah Dean
// Email: sdean12@sdean12.org
// WWW:   http://www.SDean12.org/
//
// -----------------------------------------------------------------------------
//


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, PasswordRichEdit, Spin64, ExtCtrls,
  MouseRNG,
  OTFEFreeOTFE_DriverAPI,  // Required for CRITICAL_DATA_LEN
  OTFEFreeOTFE_U,
  OTFEFreeOTFE_WizardCommon, SDUFilenameLabel, OTFEFreeOTFE_fmeSelectPartition;


type
  TChangePasswordCreateKeyfile = (opChangePassword, opCreateKeyfile);

  TfrmWizardChangePasswordCreateKeyfile = class(TForm)
    pcWizard: TPageControl;
    tsSrcDetails: TTabSheet;
    tsDestDetails: TTabSheet;
    reInstructDestDetails: TRichEdit;
    pnlButtons: TPanel;
    lblStage: TLabel;
    lblCompleteIndicator: TLabel;
    pbNext: TButton;
    pbBack: TButton;
    pbFinish: TButton;
    pbCancel: TButton;
    pbStage: TProgressBar;
    reInstructSrcDetails: TRichEdit;
    tsRNGMouseMovement: TTabSheet;
    reInstructRNGMouseMovement: TRichEdit;
    MouseRNG: TMouseRNG;
    lblMouseRNGBits: TLabel;
    tsDestFile: TTabSheet;
    reInstructDestFile: TRichEdit;
    tsRNGGPG: TTabSheet;
    reInstructRNGGPG: TRichEdit;
    GroupBox5: TGroupBox;
    lblGPGFilename: TSDUFilenameLabel;
    pbBrowseGPG: TButton;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    GPGOpenDialog: TOpenDialog;
    tsRNGSelect: TTabSheet;
    reInstructRNGSelect: TRichEdit;
    Label9: TLabel;
    Label10: TLabel;
    se64Offset: TSpinEdit64;
    Label1: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    preSrcUserKey: TPasswordRichEdit;
    seSrcSaltLength: TSpinEdit64;
    Label2: TLabel;
    preDestUserKey1: TPasswordRichEdit;
    preDestUserKey2: TPasswordRichEdit;
    Label3: TLabel;
    Label5: TLabel;
    seDestSaltLength: TSpinEdit64;
    Label7: TLabel;
    cbDestDriveLetter: TComboBox;
    Label12: TLabel;
    GroupBox1: TGroupBox;
    lblDestFilename: TSDUFilenameLabel;
    pbBrowseDest: TButton;
    tsSrcFile: TTabSheet;
    reInstructSrcFile: TRichEdit;
    GroupBox2: TGroupBox;
    lblSrcFilename: TSDUFilenameLabel;
    pbBrowseSrc: TButton;
    tsFileOrPartition: TTabSheet;
    tsPartitionSelect: TTabSheet;
    rgFileOrPartition: TRadioGroup;
    reInstructFileOrPartition: TRichEdit;
    reInstructPartitionSelect: TRichEdit;
    Label21: TLabel;
    seDestKeyIterations: TSpinEdit64;
    Label8: TLabel;
    seSrcKeyIterations: TSpinEdit64;
    Label11: TLabel;
    gbRNG: TGroupBox;
    ckRNGMouseMovement: TCheckBox;
    ckRNGCryptoAPI: TCheckBox;
    ckRNGcryptlib: TCheckBox;
    ckRNGGPG: TCheckBox;
    ckRNGPKCS11: TCheckBox;
    tsRNGPKCS11: TTabSheet;
    reInstructRNGPKCS11: TRichEdit;
    cbToken: TComboBox;
    lblToken: TLabel;
    pbRefresh: TButton;
    fmeSelectPartition: TfmeSelectPartition;
    procedure pbCancelClick(Sender: TObject);
    procedure pbNextClick(Sender: TObject);
    procedure pbBackClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure edSrcFilenameChange(Sender: TObject);
    procedure se64OffsetChange(Sender: TObject);
    procedure preUserKeyChange(Sender: TObject);
    procedure seSaltLengthChange(Sender: TObject);
    procedure ckRNGClick(Sender: TObject);
    procedure MouseRNGByteGenerated(Sender: TObject; random: Byte);
    procedure pbBrowseGPGClick(Sender: TObject);
    procedure pbFinishClick(Sender: TObject);
    procedure pbBrowseDestClick(Sender: TObject);
    procedure pbBrowseSrcClick(Sender: TObject);
    procedure rgFileOrPartitionClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure pbRefreshClick(Sender: TObject);
  private

    fCombinedRandomData: string;

    deviceList: TStringList;
    deviceTitle: TStringList;

    CanUseCryptlib: boolean;
    FPKCS11TokensAvailable: boolean;

    function  GetRNGSet(): TRNGSet;

    function  GetIsPartition(): boolean;
    function  GetSrcFilename(): string;
    function  GetOffset(): int64;
    function  GetSrcUserKey(): string;
    function  GetSrcSaltLength(): integer;
    function  GetSrcKeyIterations(): integer;
    function  GetDestFilename(): string;
    procedure SetDestFilename(filename: string);
    function  GetDestUserKey(): string;
    function  GetDestSaltLength(): integer;
    function  GetDestKeyIterations(): integer;
    function  GetDestRequestedDriveLetter(): char;
    function  GetRandomData(): string;

    procedure PopulatePKCS11Tokens();

    function  NextTabInDir(gotoNext: boolean): TTabSheet;
    function  SkipTab(tabSheet: TTabSheet): boolean;
    procedure UpdateStageDisplay();

    procedure EnableDisableControls();
    procedure CheckCurrentTabComplete();

    procedure SetupDisplayCommon();
    procedure SetupDisplayCreateKeyfile();
    procedure SetupDisplayChangePassword();

  public
    ChangePasswordCreateKeyfile: TChangePasswordCreateKeyfile;

    procedure fmeSelectPartitionChanged(Sender: TObject);

  published
    OTFEFreeOTFE: TOTFEFreeOTFE;

    property IsPartition: boolean read GetIsPartition;
    property SrcFilename: string read GetSrcFilename;
    property Offset: int64 read GetOffset;
    property SrcUserKey: string read GetSrcUserKey;
    property SrcSaltLength: integer read GetSrcSaltLength;
    property SrcKeyIterations: integer read GetSrcKeyIterations;
    property DestFilename: string read GetDestFilename write SetDestFilename;
    property DestUserKey: string read GetDestUserKey;
    property DestSaltLength: integer read GetDestSaltLength;
    property DestKeyIterations: integer read GetDestKeyIterations;
    property DestRequestedDriveLetter: char read GetDestRequestedDriveLetter;
    property RandomData: string read GetRandomData;

  end;


implementation

{$R *.DFM}

uses
  SDUGeneral,
  SDUDialogs,
  MSCryptoAPI,
  OTFEFreeOTFE_PKCS11;

const
  FILEORPART_OPT_VOLUME_FILE = 'File';
  FILEORPART_OPT_PARTITION   = 'Partition';


procedure TfrmWizardChangePasswordCreateKeyfile.pbCancelClick(
  Sender: TObject);
begin
  ModalResult := mrCancel;

end;

function TfrmWizardChangePasswordCreateKeyfile.GetSrcFilename(): string;
var
  retVal: string;
begin
  retVal := '';

  if (IsPartition) then
    begin
    retVal := fmeSelectPartition.SelectedDevice;
    end
  else
    begin
    retVal:= lblSrcFilename.Caption;
    end;

  Result := retVal;
end;

function TfrmWizardChangePasswordCreateKeyfile.GetOffset(): int64;
begin
  Result := se64Offset.Value;
end;

function TfrmWizardChangePasswordCreateKeyfile.GetSrcUserKey(): string;
begin
  Result := preSrcUserKey.Text;
end;

function TfrmWizardChangePasswordCreateKeyfile.GetSrcSaltLength(): integer;
begin
  Result := seSrcSaltLength.Value;
end;

function TfrmWizardChangePasswordCreateKeyfile.GetDestFilename(): string;
begin
  Result := lblDestFilename.Caption;
end;

procedure TfrmWizardChangePasswordCreateKeyfile.SetDestFilename(filename: string);
begin
  lblDestFilename.Caption := filename;
end;

function TfrmWizardChangePasswordCreateKeyfile.GetDestUserKey(): string;
begin
  Result := preDestUserKey1.Text;
end;

function TfrmWizardChangePasswordCreateKeyfile.GetDestSaltLength(): integer;
begin
  Result := seDestSaltLength.Value;
end;

function TfrmWizardChangePasswordCreateKeyfile.GetSrcKeyIterations(): integer;
begin
  Result := seSrcKeyIterations.Value;
end;

function TfrmWizardChangePasswordCreateKeyfile.GetDestKeyIterations(): integer;
begin
  Result := seDestKeyIterations.Value;
end;

function TfrmWizardChangePasswordCreateKeyfile.GetDestRequestedDriveLetter(): char;
var
  driveLetter: char;
begin
  driveLetter := #0;
  if (cbDestDriveLetter.ItemIndex > 0) then
    begin
    driveLetter := cbDestDriveLetter.Items[cbDestDriveLetter.ItemIndex][1];
    end;

  Result := driveLetter;
end;


function TfrmWizardChangePasswordCreateKeyfile.GetRandomData(): string;
begin
  Result := fCombinedRandomData;
end;


// Get the next tabsheet in the specified direction
// gotoNext - Set to TRUE to go to the next tab, set to FALSE to go to the
//            previous tab
function TfrmWizardChangePasswordCreateKeyfile.NextTabInDir(gotoNext: boolean): TTabSheet;
var
  tmpSheet: TTabSheet;
  sheetSkipped: boolean;
begin
  tmpSheet := pcWizard.FindNextPage(pcWizard.ActivePage, gotoNext, FALSE);

  // Set sheetSkipped to TRUE to bootstrap the while statement
  sheetSkipped:= TRUE;
  while (sheetSkipped) do
    begin
    if (
        ( (gotoNext)    and (tmpSheet = pcWizard.Pages[0]) ) OR
        ( not(gotoNext) and (tmpSheet = pcWizard.Pages[pcWizard.PageCount-1]) )
       ) then
      begin
      // Wrapped; no more pages in the specified direction, so break & return
      // nil
      tmpSheet := nil;
      break;
      end;

    sheetSkipped:= SkipTab(tmpSheet);

    if (sheetSkipped) then
      begin
      tmpSheet.Tag := 1; // Skipped sheets are always complete
      tmpSheet := pcWizard.FindNextPage(tmpSheet, gotoNext, FALSE);
      end;

    end;  // while (sheetSkipped) do

  Result := tmpSheet;
end;


// Returns TRUE if the specified tab should be skipped, otherwise FALSE
function TfrmWizardChangePasswordCreateKeyfile.SkipTab(tabSheet: TTabSheet): boolean;
var
  sheetSkipped: boolean;
begin
  sheetSkipped:= FALSE;

  // If the user isn't creating a volume within a volume file, skip that tab
  if (tabSheet = tsSrcFile) then
    begin
    sheetSkipped := IsPartition;
    end;

  // If the user isn't creating a volume on a partition, skip that tab
  if (tabSheet = tsPartitionSelect) then
    begin
    sheetSkipped := not(IsPartition);
    end;

  // If the user isn't creating a keyfile, skip the destination keyfile tabsheet
  if (tabSheet = tsDestFile) then
    begin
    sheetSkipped := (ChangePasswordCreateKeyfile <> opCreateKeyfile);
    end;

  // If the user *isn't* using the mouse movement RNG, skip the tsRNGMouseMovement tabsheet
  if (tabSheet = tsRNGMouseMovement) then
    begin
    sheetSkipped := not(rngMouseMovement in GetRNGSet());
    end;

  // If the user *isn't* using the PKCS#11 token RNG, skip the tsRNGPKCS11 tabsheet
  if (tabSheet = tsRNGPKCS11) then
    begin
    sheetSkipped := not(rngPKCS11 in GetRNGSet());
    end;

  // If the user *isn't* using the GPG RNG, skip the tsRNGGPG tabsheet
  if (tabSheet = tsRNGGPG) then
    begin
    sheetSkipped := not(rngGPG in GetRNGSet());
    end;

  Result := sheetSkipped;
end;


procedure TfrmWizardChangePasswordCreateKeyfile.UpdateStageDisplay();
var
  totalStages: integer;
  currStage: integer;
  i: integer;
begin
  // This functions also sets the stage x/y progress display
  totalStages := pcWizard.PageCount;
  currStage := pcWizard.ActivePageIndex + 1;

  for i:=0 to (pcWizard.PageCount-1) do
    begin
    if SkipTab(pcWizard.Pages[i]) then
      begin
      dec(totalStages);
      if SDUIsTabSheetAfter(pcWizard, pcWizard.Pages[i], pcWizard.ActivePage) then
        begin
        dec(currStage);
        end;
      end;

    end;


  pbStage.Min := 1;
  pbStage.Max := totalStages;
  pbStage.Position := currStage;

  lblStage.Caption := 'Stage '+inttostr(currStage)+' of '+inttostr(totalStages);

end;


procedure TfrmWizardChangePasswordCreateKeyfile.pbNextClick(Sender: TObject);
var
  newTab: TTabSheet;
begin
  newTab := NextTabInDir(TRUE);
  if (newTab <> nil) then
    begin
    pcWizard.ActivePage := newTab;
    CheckCurrentTabComplete();

    // Any wizard-specific code here (e.g. populating summary tab)
    if (pcWizard.ActivePage = tsPartitionSelect) then
      begin
      // This shouldn't be needed, but without it, controls on this frame which
      // are set to "Visible := FALSE" by the frame remain visible.
      // Only call Initialize(...) the first time the tab is moved onto
      if (fmeSelectPartition.Tag = 1) then
        begin
        fmeSelectPartition.Initialize();
        fmeSelectPartition.Tag := 0;
        end;
      end;
      
    end;

end;


procedure TfrmWizardChangePasswordCreateKeyfile.pbBackClick(Sender: TObject);
var
  newTab: TTabSheet;
begin
  newTab := NextTabInDir(FALSE);
  if (newTab <> nil) then
    begin
    pcWizard.ActivePage := newTab;
    CheckCurrentTabComplete();
    end;

end;



procedure TfrmWizardChangePasswordCreateKeyfile.EnableDisableControls();
var
  allDone: boolean;
  i: integer;
begin
  // Enable/disable the standard wizard Back, Next, Finish and Cancel buttons
  
  // If there's a tab to "Next>" *to*, and we've completed the current tab...
  pbNext.Enabled := (NextTabInDir(TRUE) <> nil) and (pcWizard.ActivePage.Tag = 1);
  
  pbBack.Enabled := (pcWizard.ActivePageIndex > 0);
                                        
  allDone := TRUE;
  lblCompleteIndicator.caption := '';
  for i:=0 to (pcWizard.PageCount-1) do
    begin
    allDone := allDone AND (pcWizard.Pages[i].Tag = 1);
    if not(pcWizard.Pages[i].Tag = 1) then
      begin
      lblCompleteIndicator.caption := lblCompleteIndicator.caption +' -- '+inttostr(i);
      end;
    end;
  pbFinish.Enabled := allDone;

  // Change default button as sensible
  pbBack.Default   := FALSE;
  pbNext.Default   := FALSE;
  pbFinish.Default := FALSE;
  if pbFinish.Enabled then                                 
    begin
    pbFinish.Default := TRUE;
    end
  else if pbNext.Enabled then
    begin
    pbNext.Default := TRUE;
    end
  else if pbBack.Enabled then
    begin
    pbBack.Default := TRUE;
    end;


  // From here on, enable/disable controls as specific to the wizard...

  
  // (No wizard specific code for *this* wizard.)
  
end;


// This procedure will check to see if all items on the current tabsheet have
// been successfully completed
procedure TfrmWizardChangePasswordCreateKeyfile.CheckCurrentTabComplete();
var
  allOK: boolean;
  randomBitsGenerated: integer;
begin
  allOK := FALSE;

  if (pcWizard.ActivePage = tsFileOrPartition) then
    begin
    // Ensure one option has been selected
    allOK := (rgFileOrPartition.ItemIndex >= 0);
    end
  else if (pcWizard.ActivePage = tsSrcFile) then
    begin
    // Flag tabsheet complete if a valid filename has been specified
    if (IsPartition) then
      begin
      allOK := TRUE;
      end
    else
      begin
      allOK := FileExists(SrcFilename);
      end;

    end
  else if (pcWizard.ActivePage = tsPartitionSelect) then
    begin
    // If we're creating a volume on a partition, one must be selected
    if (not(IsPartition)) then
      begin
      allOK := TRUE;
      end
    else
      begin
      allOK := (fmeSelectPartition.SelectedDevice <> '');
      end;

    end
  else if (pcWizard.ActivePage = tsSrcDetails) then
    begin
    // Check that the number entered is less than the max size...
    if (IsPartition) then
      begin
      allOK := (Offset >= 0);
      end
    else
      begin
      allOK := (Offset < SDUGetFileSize(SrcFilename)) AND (Offset >= 0);
      end;

    // Check that the number entered is less than the size of the file...
    // Src salt length >= 0
    // Note that the password *can* be blank - e.g. with the NULL encryption
    // cypher
    allOK := allOK AND
            (SrcSaltLength >= 0) AND
            (SrcKeyIterations > 0);
    end
  else if (pcWizard.ActivePage = tsDestFile) then
    begin
    // Dest filename entered
    allOK := (DestFilename <> '');

    // Sanity check - if we're creating a keyfile, ensure user's not trying to
    // overwrite the original volume file!
    if (ChangePasswordCreateKeyfile = opCreateKeyfile) then
      begin
      allOK := allOK AND (SrcFilename <> DestFilename);
      end;

    end
  else if (pcWizard.ActivePage = tsDestDetails) then
    begin
    // Check that user password is confirmed
    // Note that RNG is always set to something, and others always default
    // Note that the password *can* be blank - e.g. with the NULL encryption
    // cypher
    allOK := (preDestUserKey1.Text = preDestUserKey2.Text) and
             (DestSaltLength >= 0) AND
             (DestKeyIterations > 0);
    end
  else if (pcWizard.ActivePage = tsRNGSelect) then
    begin
    // Must have at least one RNG selected
    allOK := (GetRNGSet() <> []);
    end
  else if (pcWizard.ActivePage = tsRNGMouseMovement) then
    begin
    // This is a good place to update the display of the number of random bits
    // generated...
    randomBitsGenerated:= CountMouseRNGData();
    lblMouseRNGBits.Caption := 'Random bits generated: '+inttostr(randomBitsGenerated)+'/'+inttostr(CRITICAL_DATA_LENGTH);

    allOK := (randomBitsGenerated >= CRITICAL_DATA_LENGTH);
    MouseRNG.Enabled := not(allOK);
    if MouseRNG.Enabled then
      begin
      MouseRNG.Color := clWindow;
      end
    else
      begin
      MouseRNG.Color := clBtnFace;
      end;

    end
  else if (pcWizard.ActivePage = tsRNGPKCS11) then
    begin
    // Must have at least one RNG selected
    allOK := (
              FPKCS11TokensAvailable and
              (cbToken.ItemIndex >= 0)
             );
    end
  else if (pcWizard.ActivePage = tsRNGGPG) then
    begin
    // Flag tabsheet complete if a GPG executable has been specified
    allOK := (lblGPGFilename.Caption <> '');
    end;


  pcWizard.ActivePage.Tag := 0;
  if allOK then
    begin
    pcWizard.ActivePage.Tag := 1;
    end;

  EnableDisableControls();

  // This is a good time to update the stage X of Y display - any changes to
  // the tab's settings may have reduced/increased the number of stages
  UpdateStageDisplay();

end;



procedure TfrmWizardChangePasswordCreateKeyfile.FormShow(Sender: TObject);
var
  i: integer;
  dl: char;
begin
  fCombinedRandomData := '';

  // Set this to TRUE or comment out the next line for debug
  lblCompleteIndicator.Visible := FALSE;

  // We change the style to one of the "flat" styles so that no border is shown
  pcWizard.Style := tsFlatButtons;

  // We don't set these at design-time, as it makes it easier to see where the
  // components are

  reInstructFileOrPartition.BorderStyle  := bsNone;
  reInstructSrcFile.BorderStyle          := bsNone;
  reInstructPartitionSelect.BorderStyle  := bsNone;
  reInstructSrcDetails.BorderStyle       := bsNone;
  reInstructDestFile.BorderStyle         := bsNone;
  reInstructDestDetails.BorderStyle      := bsNone;
  reInstructRNGSelect.BorderStyle        := bsNone;
  reInstructRNGMouseMovement.BorderStyle := bsNone;
  reInstructRNGGPG.BorderStyle           := bsNone;
  reInstructRNGPKCS11.BorderStyle        := bsNone;

  reInstructFileOrPartition.TabStop  := FALSE;
  reInstructSrcFile.TabStop          := FALSE;
  reInstructPartitionSelect.TabStop  := FALSE;
  reInstructSrcDetails.TabStop       := FALSE;
  reInstructDestFile.TabStop         := FALSE;
  reInstructDestDetails.TabStop      := FALSE;
  reInstructRNGSelect.TabStop        := FALSE;
  reInstructRNGMouseMovement.TabStop := FALSE;
  reInstructRNGGPG.TabStop           := FALSE;
  reInstructRNGPKCS11.TabStop        := FALSE;

  // Blank out instructions so it's obvious if any are missed out
  reInstructFileOrPartition.PlainText  := TRUE;
  reInstructSrcFile.PlainText          := TRUE;
  reInstructPartitionSelect.PlainText  := TRUE;
  reInstructSrcDetails.PlainText       := TRUE;
  reInstructDestFile.PlainText         := TRUE;
  reInstructDestDetails.PlainText      := TRUE;
  reInstructRNGSelect.PlainText        := TRUE;
  reInstructRNGMouseMovement.PlainText := TRUE;
  reInstructRNGGPG.PlainText           := TRUE;
  reInstructRNGPKCS11.PlainText        := TRUE;

  reInstructFileOrPartition.Lines.Clear();
  reInstructSrcFile.Lines.Clear();
  reInstructPartitionSelect.Lines.Clear();
  reInstructSrcDetails.Lines.Clear();
  reInstructDestFile.Lines.Clear();
  reInstructDestDetails.Lines.Clear();
  reInstructRNGSelect.Lines.Clear();
  reInstructRNGMouseMovement.Lines.Clear();
  reInstructRNGGPG.Lines.Clear();
  reInstructRNGPKCS11.Lines.Clear();


  pnlButtons.Caption := '';
  pnlButtons.BevelInner := bvNone;
  pnlButtons.BevelOuter := bvNone;


  if (ChangePasswordCreateKeyfile = opChangePassword) then
    begin
    SetupDisplayChangePassword();
    end
  else
    begin
    SetupDisplayCreateKeyfile();
    end;



  // Select the first tab
  // This is done to ensure that the "master key length" tab isn't selected
  // during initialization; if it is then it'll be checked to see if it's
  // complete during initialization - and since it requires the user to
  // have selected a cypher, it will fail to get the cypher's keylen
  pcWizard.ActivePageIndex := 0;

  // tsFileOrPartition
  rgFileOrPartition.Items.Clear();
  rgFileOrPartition.Items.Add(FILEORPART_OPT_VOLUME_FILE);
  rgFileOrPartition.Items.Add(FILEORPART_OPT_PARTITION);
  rgFileOrPartition.ItemIndex := rgFileOrPartition.Items.IndexOf(FILEORPART_OPT_VOLUME_FILE);

  // tsSrcFile
  lblSrcFilename.Caption := '';
  seSrcKeyIterations.MinValue := 1;
  seSrcKeyIterations.MaxValue := 999999; // Need *some* upper value, otherwise setting MinValue won't work properly
  seSrcKeyIterations.Increment := DEFAULT_KEY_ITERATIONS_INCREMENT;
  seSrcKeyIterations.Value := DEFAULT_KEY_ITERATIONS;

  // tsPartitionSelect
  // Setup and make sure nothing is selected
  fmeSelectPartition.FreeOTFEObj := OTFEFreeOTFE;
  // Only list CDROMs if we're creating a keyfile
  //  - CDROMs can't have their passwords changed
  fmeSelectPartition.AllowCDROM := (ChangePasswordCreateKeyfile = opCreateKeyfile);
  fmeSelectPartition.OnChange := fmeSelectPartitionChanged;
  fmeSelectPartition.Tag := 1;
  fmeSelectPartition.Initialize();

  // tsSrcDetails
  preSrcUserKey.Plaintext := TRUE;
  // FreeOTFE volumes CAN have newlines in the user's password
  preSrcUserKey.WantReturns := TRUE;
  preSrcUserKey.WordWrap := TRUE;
  preSrcUserKey.Lines.Clear();
  preSrcUserKey.PasswordChar := '*';

  se64Offset.Value := 0;

  seSrcSaltLength.Increment := 8;
  seSrcSaltLength.Value := DEFAULT_SALT_LENGTH;

  // tsDestFile
  lblDestFilename.Caption := '';

  // tsDestDetails
  preDestUserKey1.Plaintext := TRUE;
  // FreeOTFE volumes CAN have newlines in the user's password
  preDestUserKey1.WantReturns := TRUE;
  preDestUserKey1.WordWrap := TRUE;
  preDestUserKey1.Lines.Clear();
  preDestUserKey1.PasswordChar := '*';

  preDestUserKey2.Plaintext := TRUE;
  // FreeOTFE volumes CAN have newlines in the user's password
  preDestUserKey2.WantReturns := TRUE;
  preDestUserKey2.WordWrap := TRUE;
  preDestUserKey2.Lines.Clear();
  preDestUserKey2.PasswordChar := '*';

  seDestSaltLength.Increment := 8;
  seDestSaltLength.Value := DEFAULT_SALT_LENGTH;

  seDestKeyIterations.MinValue := 1;
  seDestKeyIterations.MaxValue := 999999; // Need *some* upper value, otherwise setting MinValue won't work properly
  seDestKeyIterations.Increment := DEFAULT_KEY_ITERATIONS_INCREMENT;
  seDestKeyIterations.Value := DEFAULT_KEY_ITERATIONS;

  cbDestDriveLetter.Items.Clear();
  cbDestDriveLetter.Items.Add('Use default');
  for dl:='C' to 'Z' do
    begin
    cbDestDriveLetter.Items.Add(dl+':');
    end;
  // Autoselect the "default" (first) entry
  cbDestDriveLetter.ItemIndex := 0;

  // tsRNGSelect
  ckRNGCryptoAPI.checked := TRUE;
  ckRNGcryptlib.Enabled := CanUseCryptlib;
  ckRNGPKCS11.Enabled :=  PKCS11LibraryReady(OTFEFreeOTFE.PKCS11Library);

  // tsRNGMouseMovement
  InitMouseRNGData();

  // tsRNGPKCS11
  PopulatePKCS11Tokens();

  // tsRNGGPG
  lblGPGFilename.Caption := '';



  // Set all tabs to show that they have not yet been completed
  for i:=0 to (pcWizard.PageCount-1) do
    begin
    pcWizard.Pages[i].TabVisible := FALSE;
    // Each tabsheet's tag indicates if that tab has been completed or not; 1 for
    // completed, 0 for not yet complete
    pcWizard.Pages[i].Tag := 0;
    end;


  // BECAUSE WE DEFAULTED TO USING A VOLUME *FILE*, WE MUST SET THE PARTITION
  // SELECT PAGE TO "DONE" HERE (otherwise, it'll never be flagged as complete
  // if the user doens't switch)
  tsPartitionSelect.Tag := 1;

  // BECAUSE WE DEFAULTED TO USING THE MOUSERNG, WE MUST SET THE GPG PAGE TO
  // "DONE" HERE (otherwise, it'll never be flagged as complete if the user
  // doens't switch RNGs)
  tsRNGGPG.Tag := 1;

  // Select the first tab
  // Yes, this is required; get an access violation if this isn't done
  pcWizard.ActivePageIndex := 0;

  CheckCurrentTabComplete();

end;


procedure TfrmWizardChangePasswordCreateKeyfile.edSrcFilenameChange(
  Sender: TObject);
begin
  if (ChangePasswordCreateKeyfile = opChangePassword) then
    begin
    DestFilename := SrcFilename;
    end;
  CheckCurrentTabComplete();

end;

procedure TfrmWizardChangePasswordCreateKeyfile.se64OffsetChange(
  Sender: TObject);
begin
  CheckCurrentTabComplete();

end;

procedure TfrmWizardChangePasswordCreateKeyfile.preUserKeyChange(
  Sender: TObject);
begin
  CheckCurrentTabComplete();

end;

procedure TfrmWizardChangePasswordCreateKeyfile.seSaltLengthChange(
  Sender: TObject);
begin
  CheckCurrentTabComplete();

end;

procedure TfrmWizardChangePasswordCreateKeyfile.ckRNGClick(
  Sender: TObject);
begin
  InitMouseRNGData();

  // Set unused tabsheets as complete
  // ...RNG mouse movement
  tsRNGMouseMovement.Tag := 1;
  if ckRNGMouseMovement.checked then
    begin
    tsRNGMouseMovement.Tag := 0;
    end;

  // ...RNG GPG
  tsRNGGPG.Tag := 1;
  if ckRNGGPG.checked then
    begin
    if (lblGPGFilename.Caption = '') then
      begin
      tsRNGGPG.Tag := 0;
      end;
    end;

  // ...RNG PKCS#11 token
  tsRNGPKCS11.Tag := 1;
  if ckRNGPKCS11.checked then
    begin
    if not(
           FPKCS11TokensAvailable and
           (cbToken.ItemIndex >= 0)
          ) then
      begin
      tsRNGPKCS11.Tag := 0;
      end;
    end;


  CheckCurrentTabComplete();

end;

procedure TfrmWizardChangePasswordCreateKeyfile.MouseRNGByteGenerated(
  Sender: TObject; random: Byte);
begin
  // Note: This is correct; if it's *less than* CRITICAL_DATA_LEN, then store it
  if (CountMouseRNGData() < CRITICAL_DATA_LENGTH) then
    begin
    AddToMouseRNGData(random);
    end;

  CheckCurrentTabComplete();

end;

procedure TfrmWizardChangePasswordCreateKeyfile.pbBrowseGPGClick(
  Sender: TObject);
begin
  SaveDialog.Filter     := FILE_FILTER_FLT_KEYFILES;
  SaveDialog.DefaultExt := FILE_FILTER_DFLT_KEYFILES;

  SDUOpenSaveDialogSetup(GPGOpenDialog, lblGPGFilename.caption);
  if GPGOpenDialog.execute then
    begin
    lblGPGFilename.caption := GPGOpenDialog.Filename;
    end;

  CheckCurrentTabComplete();

end;


function TfrmWizardChangePasswordCreateKeyfile.GetRNGSet(): TRNGSet;
var
  retval: TRNGSet;
begin
  retval := [];

  if ckRNGCryptoAPI.checked then
    begin
    retval := retval + [rngCryptoAPI];
    end;

  if ckRNGMouseMovement.checked then
    begin
    retval := retval + [rngMouseMovement];
    end;

  if ckRNGcryptlib.checked then
    begin
    retval := retval + [rngcryptlib];
    end;

  if ckRNGPKCS11.checked then
    begin
    retval := retval + [rngPKCS11];
    end;

  if ckRNGGPG.checked then
    begin
    retval := retval + [rngGPG];
    end;

  Result := retval;
end;


procedure TfrmWizardChangePasswordCreateKeyfile.pbFinishClick(
  Sender: TObject);
var
  allOK: boolean;
  randomPool: string;
  saltBytes: string;
begin
  allOK := GenerateRandomData(
                              GetRNGSet(),
                              (CRITICAL_DATA_LENGTH div 8),
                              OTFEFreeOTFE.PKCS11Library,
                              PKCS11TokenListSelected(cbToken),
                              lblGPGFilename.Caption,
                              fCombinedRandomData
                             );


  if (allOK) then
    begin
    randomPool:= RandomData;

    // Grab 'n' bytes from the random pool to use as the salt
    saltBytes := Copy(randomPool, 1, (DestSaltLength div 8));
    Delete(randomPool, 1, (DestSaltLength div 8));

    if (ChangePasswordCreateKeyfile = opChangePassword) then
      begin
      allOK := OTFEFreeOTFE.ChangeVolumePassword(
                                           SrcFilename,
                                           Offset,
                                           SrcUserKey,
                                           SrcSaltLength,  // In bits
                                           SrcKeyIterations,
                                           DestUserKey,
                                           saltBytes,
                                           DestKeyIterations,
                                           DestRequestedDriveLetter,
                                           randomPool
                                          );
      end
    else
      begin
      allOK := OTFEFreeOTFE.CreateKeyfile(
                                           SrcFilename,
                                           Offset,
                                           SrcUserKey,
                                           SrcSaltLength,  // In bits
                                           SrcKeyIterations,
                                           DestFilename,
                                           DestUserKey,
                                           saltBytes,
                                           DestKeyIterations,
                                           DestRequestedDriveLetter,
                                           randomPool
                                          );
      end;


    if (allOK) then
      begin
      SDUMessageDlg('Completed successfully.', mtInformation, [mbOK], 0);
      ModalResult := mrOK;
      end
    else
      begin
      SDUMessageDlg(
                 'Unable to complete requested operation: please ensure that '+SDUCRLF+
                 'your encrypted volume is not mounted or otherwise in use, and '+SDUCRLF+
                 'that the password, salt and offset entered is correct.',
                 mtError, [mbOK], 0);
      end;

    end;

end;


procedure TfrmWizardChangePasswordCreateKeyfile.SetupDisplayChangePassword();
begin
  self.Caption := 'Change Password/Other Details';

  SetupDisplayCommon();

  reInstructFileOrPartition.Lines.Add('Please specify whether the volume you wish to modify is file or partition based.');

  reInstructSrcFile.Lines.Add('Please enter the full path and filename of the volume/keyfile you wish to change.');
  reInstructSrcFile.Lines.Add('');
  reInstructSrcFile.Lines.Add(
                              'If you wish to update a "hidden" volume held within another file, '+
                              'please specify the filename of the host file which stores your '+
                              'encrypted volume '
                             );

  reInstructPartitionSelect.Lines.Add('Please specify the partition your volume is stored on.');

  reInstructSrcDetails.Lines.Add('Please enter the full details of the volume/keyfile you wish to change.');
  reInstructSrcDetails.Lines.Add('');
  reInstructSrcDetails.Lines.Add(
                                 'If you wish to update a "hidden" volume held within another file, '+
                                 'please specify the offset within the host file where your hidden '+
                                 'volume is located'
                                );

  reInstructDestFile.Lines.Add('n/a');

  reInstructDestDetails.Lines.Add('Please enter new details for your volume/keyfile.');

  reInstructRNGSelect.Lines.Add('In order to change your volume/keyfile''s details, a certain amount of random data is required.');
  reInstructRNGSelect.Lines.Add('');
  reInstructRNGSelect.Lines.Add('This data will be used for the following:');
  reInstructRNGSelect.Lines.Add('');
  reInstructRNGSelect.Lines.Add('1) Password salting');
  reInstructRNGSelect.Lines.Add('2) Random padding data');
  reInstructRNGSelect.Lines.Add('');
  reInstructRNGSelect.Lines.Add(
                                'In order to generate this data, please select which random number generator '+
                                'you wish to use from the options below.'
                               );

end;


procedure TfrmWizardChangePasswordCreateKeyfile.SetupDisplayCreateKeyfile();
begin
  self.Caption := 'Create Keyfile for Volume';

  SetupDisplayCommon();

  reInstructFileOrPartition.Lines.Add('Please specify whether the volume you wish to create a keyfile for is file or partition based.');

  reInstructSrcFile.Lines.Add('Please enter the full path and filename of either:');
  reInstructSrcFile.Lines.Add('');
  reInstructSrcFile.Lines.Add('1) A volume containing a CDB, or');
  reInstructSrcFile.Lines.Add('2) An existing keyfile');
  reInstructSrcFile.Lines.Add('');
  reInstructSrcFile.Lines.Add('for the volume you wish to create a keyfile for.');
  reInstructSrcFile.Lines.Add('');
  reInstructSrcFile.Lines.Add(
                              'If you wish to update a "hidden" volume which is held within '+
                              'another file, and your hidden volume includes a CDB, please '+
                              'specify the filename of the host file which stores your encrypted '+
                              'volume.'
                             );

  reInstructPartitionSelect.Lines.Add('Please specify the partition your volume is stored on.');

  reInstructSrcDetails.Lines.Add('Please enter the full details of the volume you wish to create a keyfile for.');
  reInstructSrcDetails.Lines.Add('');
  reInstructSrcDetails.Lines.Add(
                                 'If you wish to update a "hidden" volume which is held within '+
                                 'another file, and your hidden volume includes a CDB, please  '+
                                 'specify the offset within the host file where your hidden '+
                                 'volume is located.'
                                );

  reInstructDestFile.Lines.Add('Please specify the full path and filename where the keyfile should be written to.');

  reInstructDestDetails.Lines.Add('Please specify the details for your new keyfile.');

  reInstructRNGSelect.Lines.Add('In order to create a new keyfile, a certain amount of random data is required.');
  reInstructRNGSelect.Lines.Add('');
  reInstructRNGSelect.Lines.Add('This data will be used for the following:');
  reInstructRNGSelect.Lines.Add('');
  reInstructRNGSelect.Lines.Add('1) Password salting');
  reInstructRNGSelect.Lines.Add('2) Random padding data');
  reInstructRNGSelect.Lines.Add('');
  reInstructRNGSelect.Lines.Add(
                                'In order to generate this data, please select which random number generator '+
                                'you wish to use from the options below.'
                               );

end;


procedure TfrmWizardChangePasswordCreateKeyfile.SetupDisplayCommon();
begin
  reInstructRNGMouseMovement.Lines.Add('You have elected to use mouse movement to generate random data.');
  reInstructRNGMouseMovement.Lines.Add('');
  reInstructRNGMouseMovement.Lines.Add(
                                       'Please "waggle" the mouse within the area below, until enough '+
                                       'random data has been generated.'
                                      );

  reInstructRNGGPG.Lines.Add(
                             'In order to use GPG to generate random data, please specify the '+
                             'location of "gpg.exe" by clicking the browse button.'
                            );

  reInstructRNGPKCS11.Lines.Add(
                             'Please select the PKCS#11 token you wish to use to generate random data, from the list shown below'
                            );

end;


procedure TfrmWizardChangePasswordCreateKeyfile.pbBrowseDestClick(
  Sender: TObject);
begin
  SaveDialog.Filter     := FILE_FILTER_FLT_KEYFILES;
  SaveDialog.DefaultExt := FILE_FILTER_DFLT_KEYFILES;

  SDUOpenSaveDialogSetup(SaveDialog, lblDestFilename.Caption);

  if SaveDialog.Execute() then
    begin
    if (FileExists(SaveDialog.Filename)) then
      begin
      SDUMessageDlg(
                 'A file with the filename you specified already exists.'+SDUCRLF+
                 SDUCRLF+
                 'For safety reasons, you must specify a file which doesn''t already '+SDUCRLF+
                 'exist.'+SDUCRLF+
                 SDUCRLF+
                 'Please either delete the existing file, or specify a new filename.',
                 mtError, [mbOK], 0
                );
      end
    else
      begin
      lblDestFilename.Caption := SaveDialog.Filename;
      end;

    end;

  CheckCurrentTabComplete();
  
end;

procedure TfrmWizardChangePasswordCreateKeyfile.pbBrowseSrcClick(
  Sender: TObject);
begin
  OpenDialog.Filter     := FILE_FILTER_FLT_VOLUMESANDKEYFILES;
  OpenDialog.DefaultExt := FILE_FILTER_DFLT_VOLUMESANDKEYFILES;

  SDUOpenSaveDialogSetup(OpenDialog, lblSrcFilename.Caption);

  if OpenDialog.Execute() then
    begin
    lblSrcFilename.Caption := OpenDialog.Filename;
    end;
    
  CheckCurrentTabComplete();

end;

procedure TfrmWizardChangePasswordCreateKeyfile.rgFileOrPartitionClick(
  Sender: TObject);
begin
  CheckCurrentTabComplete();

end;


function TfrmWizardChangePasswordCreateKeyfile.GetIsPartition(): boolean;
begin
  Result := (rgFileOrPartition.ItemIndex = rgFileOrPartition.Items.IndexOf(FILEORPART_OPT_PARTITION));
end;

procedure TfrmWizardChangePasswordCreateKeyfile.FormCreate(
  Sender: TObject);
begin
  deviceList:= TStringList.Create();
  deviceTitle:= TStringList.Create();

  // Start cryptlib, if possible, as early as we can to allow it as much time
  // as possible to poll entropy
  CanUseCryptlib := cryptlibLoad();

  fmeSelectPartition.OnChange := fmeSelectPartitionChanged;
end;

procedure TfrmWizardChangePasswordCreateKeyfile.FormDestroy(
  Sender: TObject);
var
  i: integer;
begin
  deviceList.Free();
  deviceTitle.Free();

  // Shutdown cryptlib, if used
  if CanUseCryptlib then
    begin
    cryptlibUnload();
    CanUseCryptlib := FALSE;
    end;

  PurgeMouseRNGData();

  for i:=1 to length(fCombinedRandomData) do
    begin
    fCombinedRandomData[i] := char(i);
    end;

end;


procedure TfrmWizardChangePasswordCreateKeyfile.PopulatePKCS11Tokens();
begin
  FPKCS11TokensAvailable := (PKCS11PopulateTokenList(
                                                     OTFEFreeOTFE.PKCS11Library,
                                                     cbToken
                                                    ) > 0);
end;

procedure TfrmWizardChangePasswordCreateKeyfile.pbRefreshClick(Sender: TObject);
begin
  PopulatePKCS11Tokens();
end;

procedure TfrmWizardChangePasswordCreateKeyfile.fmeSelectPartitionChanged(Sender: TObject);
begin
  CheckCurrentTabComplete();

end;

END.


