unit OTFEFreeOTFE_frmWizardCreateVolume;
// Description:
// By Sarah Dean
// Email: sdean12@sdean12.org         
// WWW:   http://www.SDean12.org/
//
// -----------------------------------------------------------------------------
//

                 
interface
                                          
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, MouseRNG,
  OTFEFreeOTFE_U,
  OTFEFreeOTFE_VolumeFileAPI,  // Required for TVOLUME_CRITICAL_DATA
  OTFEFreeOTFE_DriverAPI,  // Required for CRITICAL_DATA_LEN
  PasswordRichEdit, Spin64,
  OTFEFreeOTFE_WizardCommon, SDUFilenameLabel, OTFEFreeOTFE_fmeSelectPartition;


type
  TfrmWizardCreateVolume = class(TForm)
    pcWizard: TPageControl;
    tsWelcome: TTabSheet;
    tsFilename: TTabSheet;
    tsHashCypherIV: TTabSheet;
    Label4: TLabel;
    Label5: TLabel;
    cbHash: TComboBox;
    cbCypher: TComboBox;
    tsRNGSelect: TTabSheet;
    tsSize: TTabSheet;
    Label6: TLabel;
    cbSizeUnits: TComboBox;
    tsOffset: TTabSheet;
    pnlWarningOffset: TPanel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    tsPassword: TTabSheet;
    reInstructFilename: TRichEdit;
    reInstructOffset: TRichEdit;
    reInstructSize: TRichEdit;
    reInstructHashCypherIV: TRichEdit;
    reInstructRNGSelect: TRichEdit;
    reInstructPassword: TRichEdit;
    Label8: TLabel;
    Label13: TLabel;
    pnlButtons: TPanel;
    pbNext: TButton;
    pbBack: TButton;
    pbFinish: TButton;
    pbCancel: TButton;
    Label14: TLabel;
    Label16: TLabel;
    lblStage: TLabel;
    Label19: TLabel;
    Bevel1: TBevel;
    GroupBox1: TGroupBox;
    pbBrowseFilename: TButton;
    lblFilename: TSDUFilenameLabel;
    Label17: TLabel;
    Label7: TLabel;
    SaveDialog: TSaveDialog;
    tsRNGMouseMovement: TTabSheet;
    reInstructRNGMouseMovement: TRichEdit;
    tsSummary: TTabSheet;
    reSummary: TRichEdit;
    pbStage: TProgressBar;
    tsRNGGPG: TTabSheet;
    reInstructRNGGPG: TRichEdit;
    GroupBox2: TGroupBox;
    lblGPGFilename: TSDUFilenameLabel;
    pbBrowseGPG: TButton;
    GPGOpenDialog: TOpenDialog;
    lblCompleteIndicator: TLabel;
    MouseRNG: TMouseRNG;
    tsMasterKeyLength: TTabSheet;
    reInstMasterKeyLen: TRichEdit;
    Label2: TLabel;
    seMasterKeyLength: TSpinEdit64;
    Label9: TLabel;
    lblMouseRNGBits: TLabel;
    pbHashInfo: TButton;
    pbCypherInfo: TButton;
    preUserKey1: TPasswordRichEdit;
    se64ByteOffset: TSpinEdit64;
    seSize: TSpinEdit64;
    preUserKey2: TPasswordRichEdit;
    Label3: TLabel;
    Label20: TLabel;
    tsFileOrPartition: TTabSheet;
    tsPartitionSelect: TTabSheet;
    reInstructFileOrPartition: TRichEdit;
    reInstructPartitionSelect: TRichEdit;
    rgFileOrPartition: TRadioGroup;
    Label21: TLabel;
    ckPartitionHidden: TCheckBox;
    ckUsePerVolumeIV: TCheckBox;
    cbSectorIVGenMethod: TComboBox;
    lblSectorIVGenMethod: TLabel;
    tsPartitionWarning: TTabSheet;
    pnlWarningPartition: TPanel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    gbRNG: TGroupBox;
    ckRNGMouseMovement: TCheckBox;
    ckRNGCryptoAPI: TCheckBox;
    ckRNGcryptlib: TCheckBox;
    ckRNGGPG: TCheckBox;
    ckRNGPKCS11: TCheckBox;
    tsRNGPKCS11: TTabSheet;
    cbToken: TComboBox;
    lblToken: TLabel;
    pbRefresh: TButton;
    reInstructRNGPKCS11: TRichEdit;
    ckSizeEntirePartitionDisk: TCheckBox;
    lblPartitionDiskSize: TLabel;
    fmeSelectPartition: TfmeSelectPartition;
    pbAdvanced: TButton;
    reInstructSummary: TRichEdit;
    procedure pbNextClick(Sender: TObject);
    procedure pbBackClick(Sender: TObject);
    procedure pbBrowseFilenameClick(Sender: TObject);
    procedure ckRNGClick(Sender: TObject);
    procedure preUserKeyChange(Sender: TObject);
    procedure seSaltLengthChange(Sender: TObject);
    procedure edByteOffsetChange(Sender: TObject);
    procedure SizeChanged(Sender: TObject);
    procedure pbBrowseGPGClick(Sender: TObject);
    procedure MouseRngByteGenerated(Sender: TObject; random: Byte);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbHashCypherIVGenChange(Sender: TObject);
    procedure pbFinishClick(Sender: TObject);
    procedure pbCancelClick(Sender: TObject);
    procedure seMasterKeyLengthChange(Sender: TObject);
    procedure seMasterKeyLengthExit(Sender: TObject);
    procedure pbHashInfoClick(Sender: TObject);
    procedure pbCypherInfoClick(Sender: TObject);
    procedure rbCDBLocationClick(Sender: TObject);
    procedure ckPartitionHiddenClick(Sender: TObject);
    procedure rgFileOrPartitionClick(Sender: TObject);
    procedure seSizeExit(Sender: TObject);
    procedure pbRefreshClick(Sender: TObject);
    procedure ckSizeEntirePartitionDiskClick(Sender: TObject);
    procedure seSizeChange(Sender: TObject);
    procedure pbAdvancedClick(Sender: TObject);
    procedure se64ByteOffsetChange(Sender: TObject);
  private
    FSaltLength: integer;  // Length in *bits*
    FRequestedDriveLetter: char;
    FCDBFilename: string;
    FKeyIterations: integer;

    // These are ordered lists corresponding to the items shown in the combobox
    hashKernelModeDriverNames: TStringList;
    hashGUIDs: TStringList;
    cypherKernelModeDriverNames: TStringList;
    cypherGUIDs: TStringList;
    IVGenMethodIDs: TStringList;

    deviceList: TStringList;
    deviceTitle: TStringList;

    fCombinedRandomData: string;

    CanUseCryptlib: boolean;
    FPKCS11TokensAvailable: boolean;

    // When the user selects a cypher, we cache it's keysize for later use.
    // This is set to CYPHER_KEYSIZE_NOT_CACHED_FLAG_KEYSIZE to indicate no keysize is cached
    fCachedCypherKeysize: integer;
    // When the user selects a cypher, we cache it's blocksize for later use.
    // This is set to CYPHER_BLOCKSIZE_NOT_CACHED_FLAG_BLOCKSIZE to indicate no blocksize is cached
    fCachedCypherBlocksize: integer;
    // When the user selects a cypher, we cache it's mode for later use.
    fCachedCypherMode: TFreeOTFECypherMode;


    // Returns the keysize for the user's selected cypher, as returned by the
    // driver
    function  SelectedCypherKeySize(): integer;
    // Returns the blocksize for the user's selected cypher, as returned by the
    // driver
    function  SelectedCypherBlockSize(): integer;
    // Returns the cypher mode for the user's selected cypher, as returned by
    // the driver
    function  SelectedCypherMode(): TFreeOTFECypherMode;

    function  GetRNGSet(): TRNGSet;

    function  GetIsPartition(): boolean;
    function  GetVolFilename(): string;
    procedure SetVolFilename(filename: string);
    function  GetOffset(): int64;
    // Note: The size returned *excludes* the size of the critical data
    function  GetSize(): int64;
    function  GetHashKernelDeviceName(): string;
    function  GetHashGUID(): TGUID;
    function  GetCypherKernelDeviceName(): string;
    function  GetCypherGUID(): TGUID;
    function  GetSectorIVGenMethod(): TFreeOTFESectorIVGenMethod;
    procedure SetSectorIVGenMethod(sectorIVGenMethod: TFreeOTFESectorIVGenMethod);
    function  GetUsePerVolumeIV(): boolean;
    function  GetMasterKeyLength(): integer;  // Returns length in *bits*
    function  GetRandomData(): string;
    function  GetPassword(): string;

    function  GetIsHidden(): boolean;
    function GetCDBInVolFile(): boolean;

    procedure PopulateHashes();
    procedure PopulateCyphers();
    procedure PopulateSectorIVGenMethods();
    procedure PopulatePKCS11Tokens();

    procedure PopulateSummary();

    function  NextTabInDir(gotoNext: boolean): TTabSheet;
    function  SkipTab(tabSheet: TTabSheet): boolean;
    procedure UpdateStageDisplay();

    procedure EnableDisableControls();
    procedure CheckCurrentTabComplete();

    function  CreateNewVolume(): boolean;

  public
    OTFEFreeOTFE: TOTFEFreeOTFE;

    property IsPartition: boolean read GetIsPartition;
    property VolFilename: string read GetVolFilename write SetVolFilename;
    property Offset: int64 read GetOffset;
    // Note: The size returned *excludes* the size of the critical data
    property Size: int64 read GetSize;
    property HashKernelDeviceName: string read GetHashKernelDeviceName;
    property HashGUID: TGUID read GetHashGUID;
    property CypherKernelDeviceName: string read GetCypherKernelDeviceName;
    property CypherGUID: TGUID read GetCypherGUID;
    property KeyIterations: integer read FKeyIterations write FKeyIterations;
    property SectorIVGenMethod: TFreeOTFESectorIVGenMethod read GetSectorIVGenMethod;
    property UsePerVolumeIV: boolean read GetUsePerVolumeIV;
    property MasterKeyLength: integer read GetMasterKeyLength;  // In *bits*
    property RandomData: string read GetRandomData;
    property Password: string read GetPassword;
    property SaltLength: integer read FSaltLength write FSaltLength;  // In *bits*
    property RequestedDriveLetter: char read FRequestedDriveLetter write FRequestedDriveLetter;
    property KeyFilename: string read FCDBFilename write FCDBFilename;
    property CDBInVolFile: boolean read GetCDBInVolFile;

    property IsHidden: boolean read GetIsHidden;

    procedure fmeSelectPartitionChanged(Sender: TObject);

  end;


implementation

{$R *.DFM}

uses
  ActiveX,  // Required for IsEqualGUID
  ComObj,  // Required for StringToGUID
  SDUGeneral,
  SDUDialogs,
  OTFEConsts_U, // Required for OTFE_ERR_USER_CANCEL
  OTFEFreeOTFE_PKCS11,
  OTFEFreeOTFE_frmWizardCreateVolumeAdvanced;

const
  // If they're available, use these as defaults...
  DEFAULT_CYPHER_TITLE = 'AES (256 bit XTS)';
  DEFAULT_HASH_TITLE   = 'SHA-512';

  DEFAULT_SECTOR_IV_GEN_METHOD = foivg64BitSectorID;

  FILEORPART_OPT_VOLUME_FILE = 'Volume file';
  FILEORPART_OPT_PARTITION   = 'Partition/entire disk';

  DUMMY_GUID = '{00000000-0000-0000-0000-000000000000}';

  CYPHER_KEYSIZE_NOT_CACHED_FLAG_KEYSIZE     = -9999;
  CYPHER_BLOCKSIZE_NOT_CACHED_FLAG_BLOCKSIZE = -9999;
  

procedure TfrmWizardCreateVolume.FormShow(Sender: TObject);
var
  i: integer;
  idx: integer;
begin
  fCombinedRandomData := '';

  SaltLength:= DEFAULT_SALT_LENGTH;
  RequestedDriveLetter:= #0;
  KeyFilename:= '';
  KeyIterations:= DEFAULT_KEY_ITERATIONS;


  // Set this to TRUE or comment out the next line for debug
  lblCompleteIndicator.Visible := FALSE;

  // We change the style to one of the "flat" styles so that no border is shown
  pcWizard.Style := tsFlatButtons;

  // We don't set these at design-time, as it makes it easier to see where the
  // components are
  reInstructFileOrPartition.BorderStyle  := bsNone;
  reInstructFilename.BorderStyle         := bsNone;
  reInstructPartitionSelect.BorderStyle  := bsNone;
  reInstructOffset.BorderStyle           := bsNone;
  reInstructSize.BorderStyle             := bsNone;
  reInstructHashCypherIV.BorderStyle     := bsNone;
  reInstMasterKeyLen.BorderStyle         := bsNone;
  reInstructRNGSelect.BorderStyle        := bsNone;
  reInstructRNGMouseMovement.BorderStyle := bsNone;
  reInstructRNGPKCS11.BorderStyle        := bsNone;
  reInstructRNGGPG.BorderStyle           := bsNone;
  reInstructPassword.BorderStyle         := bsNone;
  reInstructSummary.BorderStyle          := bsNone;

  reInstructFileOrPartition.TabStop  := FALSE;
  reInstructFilename.TabStop         := FALSE;
  reInstructPartitionSelect.TabStop  := FALSE;
  reInstructOffset.TabStop           := FALSE;
  reInstructSize.TabStop             := FALSE;
  reInstructHashCypherIV.TabStop     := FALSE;
  reInstMasterKeyLen.TabStop         := FALSE;
  reInstructRNGSelect.TabStop        := FALSE;
  reInstructRNGMouseMovement.TabStop := FALSE;
  reInstructRNGGPG.TabStop           := FALSE;
  reInstructRNGPKCS11.TabStop        := FALSE;
  reInstructPassword.TabStop         := FALSE;
  reInstructSummary.TabStop          := FALSE;


  pnlWarningOffset.Caption := '';
  pnlWarningPartition.Caption := '';

  pnlButtons.Caption := '';
  pnlButtons.BevelInner := bvNone;
  pnlButtons.BevelOuter := bvNone;


  // Select the first tab
  // This is done to ensure that the "master key length" tab isn't selected
  // during initialization; if it is then it'll be checked to see if it's
  // complete during initialization - and since it requires the user to
  // have selected a cypher, it will fail to get the cypher's keylen
  pcWizard.ActivePageIndex := 0;

  // tsFileOrPartition
  rgFileOrPartition.Items.Clear();
  rgFileOrPartition.Items.Add(FILEORPART_OPT_VOLUME_FILE);
  rgFileOrPartition.Items.Add(FILEORPART_OPT_PARTITION);
  rgFileOrPartition.ItemIndex := rgFileOrPartition.Items.IndexOf(FILEORPART_OPT_VOLUME_FILE);

  // tsPartitionSelect
  // Setup and make sure nothing is selected
  fmeSelectPartition.FreeOTFEObj := OTFEFreeOTFE;
  fmeSelectPartition.AllowCDROM := FALSE;
  fmeSelectPartition.OnChange := fmeSelectPartitionChanged;
  fmeSelectPartition.Initialize();
  fmeSelectPartition.Tag := 1;

  // tsFilename
  lblFilename.Caption := '';

  // tsOffset
  se64ByteOffset.Value := 0;

  // tsSize
  seSize.Value := 25;
  cbSizeUnits.Items.Clear();
  cbSizeUnits.Items.Add('KB');
  cbSizeUnits.Items.Add('MB');
  cbSizeUnits.Items.Add('GB');
  // Autoselect the "MB" entry
  cbSizeUnits.ItemIndex := 1;

  // tsHashCypherIV
  PopulateHashes();
  PopulateCyphers();
  PopulateSectorIVGenMethods();
  // Autoselect default, if available
  if (cbHash.Items.Count>0) then
    begin
    idx := cbHash.Items.IndexOf(DEFAULT_HASH_TITLE);
    if (idx = -1) then
      begin
      // If we can't find the default, force the user to select manually
      idx := -1;
      end;
    cbHash.ItemIndex := idx;
    end;
  // Autoselect default, if available
  if (cbCypher.Items.Count>0) then
    begin
    idx := cbCypher.Items.IndexOf(DEFAULT_CYPHER_TITLE);
    if (idx = -1) then
      begin
      // If we can't find the default, force the user to select manually
      idx := -1;
      end;
    cbCypher.ItemIndex := idx;
    end;

  // Default sector IV generation method
  SetSectorIVGenMethod(DEFAULT_SECTOR_IV_GEN_METHOD);

  // Default to using per-volume IVs
  ckUsePerVolumeIV.Checked := TRUE;

  // tsMasterKeyLen
  seMasterKeyLength.Increment := 8;
  seMasterKeyLength.Value := DEFAULT_CYPHER_KEY_LENGTH;  // In bits

  // tsRNG
  ckRNGCryptoAPI.checked := TRUE;
  ckRNGcryptlib.Enabled := CanUseCryptlib;
  ckRNGPKCS11.Enabled :=  PKCS11LibraryReady(OTFEFreeOTFE.PKCS11Library);

  // tsRNGMouseMovement
  InitMouseRNGData();

  // tsRNGPKCS11
  PopulatePKCS11Tokens();

  // tsRNGGPG
  lblGPGFilename.Caption := '';

  // tsPassword
  preUserKey1.Plaintext := TRUE;
  // FreeOTFE volumes CAN have newlines in the user's password
  preUserKey1.WantReturns := TRUE;
  preUserKey1.WordWrap := TRUE;
  preUserKey1.Lines.Clear();
  preUserKey1.PasswordChar := '*';

  preUserKey2.Plaintext := TRUE;
  // FreeOTFE volumes CAN have newlines in the user's password
  preUserKey2.WantReturns := TRUE;
  preUserKey2.WordWrap := TRUE;
  preUserKey2.Lines.Clear();
  preUserKey2.PasswordChar := '*';


  // Set all tabs to show that they have not yet been completed
  for i:=0 to (pcWizard.PageCount-1) do
    begin
    pcWizard.Pages[i].TabVisible := FALSE;
    // Each tabsheet's tag indicates if that tab has been completed or not; 1 for
    // completed, 0 for not yet complete
    pcWizard.Pages[i].Tag := 0;
    end;


  // BECAUSE WE DEFAULTED TO USING A VOLUME *FILE*, WE MUST SET THE PARTITION
  // SELECT PAGE TO "DONE" HERE (otherwise, it'll never be flagged as complete
  // if the user doesn't switch)
  tsPartitionWarning.Tag := 1;
  tsPartitionSelect.Tag := 1;

  // BECAUSE WE DEFAULTED TO USING THE MOUSERNG, WE MUST SET THE GPG PAGE TO
  // "DONE" HERE (otherwise, it'll never be flagged as complete if the user
  // doens't switch RNGs)
  tsRNGGPG.Tag := 1;


  // Summary tab marked as completed
  tsSummary.Tag := 1;


  // Select the first tab
  // Yes, this is required; get an access violation if this isn't done
  pcWizard.ActivePageIndex := 0;

  CheckCurrentTabComplete();

end;




// Get the next tabsheet in the specified direction
// gotoNext - Set to TRUE to go to the next tab, set to FALSE to go to the
//            previous tab
function TfrmWizardCreateVolume.NextTabInDir(gotoNext: boolean): TTabSheet;
var
  tmpSheet: TTabSheet;
  sheetSkipped: boolean;
begin
  tmpSheet := pcWizard.FindNextPage(pcWizard.ActivePage, gotoNext, FALSE);

  // Set sheetSkipped to TRUE to bootstrap the while statement
  sheetSkipped:= TRUE;
  while (sheetSkipped) do
    begin
    if (
        ( (gotoNext)    and (tmpSheet = pcWizard.Pages[0]) ) OR
        ( not(gotoNext) and (tmpSheet = pcWizard.Pages[pcWizard.PageCount-1]) )
       ) then
      begin
      // Wrapped; no more pages in the specified direction, so break & return
      // nil
      tmpSheet := nil;
      break;
      end;

    sheetSkipped:= SkipTab(tmpSheet);

    if (sheetSkipped) then
      begin
      tmpSheet.Tag := 1; // Skipped sheets are always complete
      tmpSheet := pcWizard.FindNextPage(tmpSheet, gotoNext, FALSE);
      end;

    end;  // while (sheetSkipped) do

  Result := tmpSheet;
end;



// Returns TRUE if the specified tab should be skipped, otherwise FALSE
function TfrmWizardCreateVolume.SkipTab(tabSheet: TTabSheet): boolean;
var
  sheetSkipped: boolean;
begin
  sheetSkipped:= FALSE;

  // If the user isn't creating a volume within a volume file, skip that tab
  if (tabSheet = tsFilename) then
    begin
    sheetSkipped := IsPartition;
    end;

  // If the user isn't creating a volume on a partition, skip that tab
  if (tabSheet = tsPartitionWarning) then
    begin
    sheetSkipped := not(IsPartition);
    end;

  // If the user isn't creating a volume on a partition, skip that tab
  if (tabSheet = tsPartitionSelect) then
    begin
    sheetSkipped := not(IsPartition);
    end;

  // Skip offset if user is't creating a hidden volume
  if (tabSheet = tsOffset) then
    begin
    sheetSkipped := not(IsHidden);
    end;

  // If the user's selected cypher has a keysize >= 0, skip the tsMasterKeyLength tabsheet
  if (tabSheet = tsMasterKeyLength) then
    begin
    if (
        (cbHash.ItemIndex > -1) and
        (cbCypher.ItemIndex > -1)
       ) then
      begin
      sheetSkipped := (SelectedCypherKeySize() >= 0);
      end;
    end;

  // If the user *isn't* using the mouse movement RNG, skip the tsRNGMouseMovement tabsheet
  if (tabSheet = tsRNGMouseMovement) then
    begin
    sheetSkipped := not(rngMouseMovement in GetRNGSet());
    end;

  // If the user *isn't* using the PKCS#11 token RNG, skip the tsRNGPKCS11 tabsheet
  if (tabSheet = tsRNGPKCS11) then
    begin
    sheetSkipped := not(rngPKCS11 in GetRNGSet());
    end;

  // If the user *isn't* using the GPG RNG, skip the tsRNGGPG tabsheet
  if (tabSheet = tsRNGGPG) then
    begin
    sheetSkipped := not(rngGPG in GetRNGSet());
    end;

  Result := sheetSkipped;
end;


procedure TfrmWizardCreateVolume.pbNextClick(Sender: TObject);
var
  newTab: TTabSheet;
begin
  newTab := NextTabInDir(TRUE);
  if (newTab <> nil) then
    begin
    pcWizard.ActivePage := newTab;
    CheckCurrentTabComplete();

    // Any wizard-specific code here (e.g. populating summary tab)
    if (pcWizard.ActivePage = tsSummary) then
      begin
      PopulateSummary();
      end
    else if (pcWizard.ActivePage = tsPartitionSelect) then
      begin
      // This shouldn't be needed, but without it, controls on this frame which
      // are set to "Visible := FALSE" by the frame remain visible.
      // Only call Initialize(...) the first time the tab is moved onto
      if (fmeSelectPartition.Tag = 1) then
        begin
        fmeSelectPartition.Initialize();
        fmeSelectPartition.Tag := 0;
        end;
      end;

    end;

end;


procedure TfrmWizardCreateVolume.pbAdvancedClick(Sender: TObject);
var
  dlg: TfrmWizardCreateVolumeAdvanced;
begin
  dlg:= TfrmWizardCreateVolumeAdvanced.Create(self);
  try
    dlg.SaltLength := SaltLength;
    dlg.DriveLetter := RequestedDriveLetter;
    dlg.CDBFilename := KeyFilename;
    dlg.KeyIterations := KeyIterations;
    if (dlg.ShowModal = mrOK) then
      begin
      SaltLength := dlg.SaltLength;
      RequestedDriveLetter := dlg.DriveLetter;
      KeyFilename := dlg.CDBFilename;
      KeyIterations := dlg.KeyIterations;

      PopulateSummary();
      end;
  finally
    dlg.Free();
  end;

end;

procedure TfrmWizardCreateVolume.pbBackClick(Sender: TObject);
var
  newTab: TTabSheet;
begin
  newTab := NextTabInDir(FALSE);
  if (newTab <> nil) then
    begin
    pcWizard.ActivePage := newTab;
    CheckCurrentTabComplete();
    end;

end;

procedure TfrmWizardCreateVolume.EnableDisableControls();
var
  allDone: boolean;
  i: integer;
  useSectorIVs: boolean;
begin
  // Enable/disable the standard wizard Back, Next, Finish and Cancel buttons
  
  // If there's a tab to "Next>" *to*, and we've completed the current tab...
  pbNext.Enabled := (NextTabInDir(TRUE) <> nil) and (pcWizard.ActivePage.Tag = 1);
  
  pbBack.Enabled := (pcWizard.ActivePageIndex > 0);
                                        
  allDone := TRUE;
  lblCompleteIndicator.caption := '';
  for i:=0 to (pcWizard.PageCount-1) do
    begin
    allDone := allDone AND (pcWizard.Pages[i].Tag = 1);
    if not(pcWizard.Pages[i].Tag = 1) then
      begin
      lblCompleteIndicator.caption := lblCompleteIndicator.caption +' -- '+inttostr(i);
      end;
    end;
  pbFinish.Enabled := allDone;

  // Change default button as sensible
  pbBack.Default   := FALSE;
  pbNext.Default   := FALSE;
  pbFinish.Default := FALSE;
  if pbFinish.Enabled then                                 
    begin
    pbFinish.Default := TRUE;
    end
  else if pbNext.Enabled then
    begin
    pbNext.Default := TRUE;
    end
  else if pbBack.Enabled then
    begin
    pbBack.Default := TRUE;
    end;


  // From here on, enable/disable controls as specific to the wizard...


  pbHashInfo.Enabled := (
                         (GetHashKernelDeviceName <> '') and
                         (not(IsEqualGUID(GetHashGUID(), StringToGUID(DUMMY_GUID))))
                        );

  pbCypherInfo.Enabled := (
                           (GetCypherKernelDeviceName <> '') and
                           (not(IsEqualGUID(GetCypherGUID(), StringToGUID(DUMMY_GUID))))
                          );


  // If:
  //  *) The selected cypher's blocksize is zero of variable, or
  //  *) The cypher uses LRW, or
  //  *) The cypher uses LRW
  // sector IVs aren't/cannot be used
  useSectorIVs := TRUE;
  if (cbCypher.ItemIndex >= 0) then
    begin
    useSectorIVs := (SelectedCypherBlockSize() > 0) and
                    (SelectedCypherMode() <> focmLRW) and
                    (SelectedCypherMode() <> focmXTS);
    end;

  if not(useSectorIVs) then
    begin
    ckUsePerVolumeIV.Checked := FALSE;
    SetSectorIVGenMethod(foivgNone);
    end;
  SDUEnableControl(cbSectorIVGenMethod, useSectorIVs);
  SDUEnableControl(ckUsePerVolumeIV, useSectorIVs);


  // Volume size related...
  
  // If the user is creating a volume on a partition/disk, give the user the
  // option of using the whole partition/disk's space
  // ...But if the user's creating a hidden partition - make sure they enter
  // the size

  // Weird, without this FALSE/TRUE, the ".Visible := " following it has no
  // effect; even though the ".Visible := " following *that* does?!!
  ckSizeEntirePartitionDisk.Visible := FALSE;
  ckSizeEntirePartitionDisk.Visible := TRUE;

  ckSizeEntirePartitionDisk.Visible := (
                                        IsPartition and
                                        not(ckPartitionHidden.checked) and
                                        not(fmeSelectPartition.SyntheticDriveLayout)
                                       );
  lblPartitionDiskSize.Visible := ckSizeEntirePartitionDisk.Visible;
  // If the control's not visible, don't let it be selected; the user enters
  // the size
  if not(ckSizeEntirePartitionDisk.Visible) then
    begin
    ckSizeEntirePartitionDisk.checked := FALSE;
    end;

  SDUEnableControl(seSize, not(ckSizeEntirePartitionDisk.checked));
  SDUEnableControl(cbSizeUnits, not(ckSizeEntirePartitionDisk.checked));

end;

procedure TfrmWizardCreateVolume.UpdateStageDisplay();
var
  totalStages: integer;
  currStage: integer;
  i: integer;
begin
  // This functions also sets the stage x/y progress display
  totalStages := pcWizard.PageCount;
  currStage := pcWizard.ActivePageIndex + 1;

  for i:=0 to (pcWizard.PageCount-1) do
    begin
    if SkipTab(pcWizard.Pages[i]) then
      begin
      dec(totalStages);
      if SDUIsTabSheetAfter(pcWizard, pcWizard.Pages[i], pcWizard.ActivePage) then
        begin
        dec(currStage);
        end;
      end;

    end;

  pbStage.Min := 1;
  pbStage.Max := totalStages;
  pbStage.Position := currStage;

  lblStage.Caption := 'Stage '+inttostr(currStage)+' of '+inttostr(totalStages);

end;


procedure TfrmWizardCreateVolume.pbBrowseFilenameClick(Sender: TObject);
begin
  SaveDialog.Filter     := FILE_FILTER_FLT_VOLUMES;
  SaveDialog.DefaultExt := FILE_FILTER_DFLT_VOLUMES;

  SDUOpenSaveDialogSetup(SaveDialog, VolFilename);
  if SaveDialog.execute then
    begin
    VolFilename := SaveDialog.Filename;
    se64ByteOffset.Value := 0;
    if (FileExists(VolFilename)) then
      begin
      // Force the user to reenter their offset, by marking the offset tabsheet
      // as incomplete
      tsOffset.Tag := 0;
      end
    else
      begin
      // New file; critical data automatically stored at the start of the file;
      // zero offset
      tsOffset.Tag := 1;
      end;

    end;

  CheckCurrentTabComplete();

end;


// This procedure will check to see if all items on the current tabsheet have
// been successfully completed
procedure TfrmWizardCreateVolume.CheckCurrentTabComplete();
var
  allOK: boolean;
  randomBitsGenerated: integer;
begin
  allOK := FALSE;

  if (pcWizard.ActivePage = tsWelcome) then
    begin
    // Always complete...
    allOK := TRUE;
    end
  else if (pcWizard.ActivePage = tsFileOrPartition) then
    begin
    // Ensure one option has been selected
    allOK := (rgFileOrPartition.ItemIndex >= 0);
    end
  else if (pcWizard.ActivePage = tsFilename) then
    begin
    // If we're creating a volume within a volume file, a filename must be specified
    if (IsPartition) then
      begin
      allOK := TRUE;
      end
    else
      begin
      // Flag tabsheet complete if a filename has been specified
      allOK := (VolFilename <> '');
      end;

    end
  else if (pcWizard.ActivePage = tsPartitionWarning) then
    begin
    // Warning only; nothing for the user to actually do on this tab
    allOK := TRUE;
    end
  else if (pcWizard.ActivePage = tsPartitionSelect) then
    begin
    // If we're creating a volume on a partition, one must be selected
    if (not(IsPartition)) then
      begin
      allOK := TRUE;
      end
    else
      begin
      allOK := (fmeSelectPartition.SelectedDevice <> '');
      end;

    end
  else if (pcWizard.ActivePage = tsOffset) then
    begin
    // atm, the offset must be a multiple of the host sector size
    allOK := ((Offset mod ASSUMED_HOST_SECTOR_SIZE) = 0);

    if allOK then
      begin
      // Check that the number entered is less than the max size...
      if (IsPartition) then
        begin
        allOK := (Offset >= 0);
        end
      else
        begin
        allOK := (Offset < SDUGetFileSize(VolFilename)) AND (Offset >= 0);
        end;
      end;

    end
  else if (pcWizard.ActivePage = tsSize) then
    begin
    if IsPartition then
      begin
      if fmeSelectPartition.SyntheticDriveLayout then
        begin
        // We don't know the size of the selected drive/partition; assume user
        // input OK
        allOK := TRUE;
        end
      else
        begin
        // Note: fmeSelectPartition.SelectedSize() already takes into account
        //       whether or not the "entire disk" option was selected on the
        //       frame
        allOK := ((fmeSelectPartition.SelectedSize() - Offset) >= (Size + int64(CRITICAL_DATA_LENGTH div 8)));
        end;
      end
    else if (FileExists(VolFilename)) then
      begin
      // If creating a hidden container, ensure that the existing file is large
      // enough to store the hidden container
      allOK := ((SDUGetFileSize(VolFilename) - Offset) >= (Size + int64(CRITICAL_DATA_LENGTH div 8)));
      end
    else
      begin
      // It would be *nice* to check that the volume the filename is stored on
      // has enough storage for the requested size volume, but that is not
      // a priority to implement right now...

      // Always completed (seSize always returns a minimum of "1", and the
      // units must always be set to something)
      allOK := TRUE;
      end;

    end
  else if (pcWizard.ActivePage = tsHashCypherIV) then
    begin
    allOK := (
              (cbHash.ItemIndex > -1) and
              (cbCypher.ItemIndex > -1)
             );
    end
  else if (pcWizard.ActivePage = tsMasterKeyLength) then
    begin
    // If the user's selected cypher has a keysize >= 0, skip the tsMasterKeyLength tabsheet
    if (SelectedCypherKeySize() >= 0) then
      begin
      allOK := TRUE;
      end
    else
      begin
      // Otherwise, the keysize must be a multiple of 8 bits
      allOK := ((seMasterKeyLength.Value mod 8) = 0);
      end;

    end
  else if (pcWizard.ActivePage = tsRNGSelect) then
    begin
    // Must have at least one RNG selected
    allOK := (GetRNGSet() <> []);
    end
  else if (pcWizard.ActivePage = tsRNGMouseMovement) then
    begin
    // This is a good place to update the display of the number of random bits
    // generated...
    randomBitsGenerated:= CountMouseRNGData();
    lblMouseRNGBits.Caption := 'Random bits generated: '+inttostr(randomBitsGenerated)+'/'+inttostr(CRITICAL_DATA_LENGTH);

    allOK := (randomBitsGenerated >= CRITICAL_DATA_LENGTH);
    MouseRNG.Enabled := not(allOK);
    if MouseRNG.Enabled then
      begin
      MouseRNG.Color := clWindow;
      end
    else
      begin
      MouseRNG.Color := clBtnFace;
      end;

    end
  else if (pcWizard.ActivePage = tsRNGPKCS11) then
    begin
    // Must have at least one RNG selected
    allOK := (
              FPKCS11TokensAvailable and
              (cbToken.ItemIndex >= 0)
             );
    end
  else if (pcWizard.ActivePage = tsRNGGPG) then
    begin
    // Flag tabsheet complete if a GPG executable has been specified
    allOK := (lblGPGFilename.Caption <> '');
    end
  else if (pcWizard.ActivePage = tsPassword) then
    begin
    // Ensure the password is confirmed, and something has been entered as a
    // password
    allOK := (preUserKey1.Text = preUserKey2.Text) and
             (preUserKey1.Text <> '');
    end
  else if (pcWizard.ActivePage = tsSummary) then
    begin
    // Always completed
    allOK := TRUE;
    end;


  pcWizard.ActivePage.Tag := 0;
  if allOK then
    begin
    pcWizard.ActivePage.Tag := 1;
    end;

  EnableDisableControls();

  // This is a good time to update the stage X of Y display - any changes to
  // the tab's settings may have reduced/increased the number of stages
  UpdateStageDisplay();

end;


procedure TfrmWizardCreateVolume.ckRNGClick(Sender: TObject);
begin
  InitMouseRNGData();

  // Set unused tabsheets as complete
  // ...RNG mouse movement
  tsRNGMouseMovement.Tag := 1;
  if ckRNGMouseMovement.checked then
    begin
    tsRNGMouseMovement.Tag := 0;
    end;

  // ...RNG GPG
  tsRNGGPG.Tag := 1;
  if ckRNGGPG.checked then
    begin
    if (lblGPGFilename.Caption = '') then
      begin
      tsRNGGPG.Tag := 0;
      end;
    end;

  // ...RNG PKCS#11 token
  tsRNGPKCS11.Tag := 1;
  if ckRNGPKCS11.checked then
    begin
    if not(
           FPKCS11TokensAvailable and
           (cbToken.ItemIndex >= 0)
          ) then
      begin
      tsRNGPKCS11.Tag := 0;
      end;
    end;


  CheckCurrentTabComplete();

end;

procedure TfrmWizardCreateVolume.ckSizeEntirePartitionDiskClick(Sender: TObject);
begin
  CheckCurrentTabComplete();
end;

procedure TfrmWizardCreateVolume.seSaltLengthChange(Sender: TObject);
begin
  CheckCurrentTabComplete();

end;

procedure TfrmWizardCreateVolume.preUserKeyChange(Sender: TObject);
begin
  CheckCurrentTabComplete();

end;

function TfrmWizardCreateVolume.GetIsPartition(): boolean;
begin
  Result := (rgFileOrPartition.ItemIndex = rgFileOrPartition.Items.IndexOf(FILEORPART_OPT_PARTITION));
end;

function TfrmWizardCreateVolume.GetIsHidden(): boolean;
begin
  // If:
  //   a) The user wants to create the volume on a partition, and has
  //      specified they want to create a hidden partition, or
  //   b) The user wants to create the volume within a volume file, but has
  //      specified the filename of an existing file
  Result := (
              (IsPartition) AND
              (ckPartitionHidden.checked)
            )
            OR
            (
              (not(IsPartition)) AND
              (FileExists(VolFilename))
            );
end;

function TfrmWizardCreateVolume.GetVolFilename(): string;
var
  retVal: string;
begin
  retVal := '';

  if (IsPartition) then
    begin
    retVal := fmeSelectPartition.SelectedDevice;
    end
  else
    begin
    retVal:= lblFilename.Caption;
    end;

  Result := retVal;
end;

procedure TfrmWizardCreateVolume.SetVolFilename(filename: string);
begin
  lblFilename.Caption := filename;
end;


function TfrmWizardCreateVolume.GetOffset(): int64;
begin
  Result := se64ByteOffset.Value;
end;

// Note: The size returned *excludes* the size of the critical data
function TfrmWizardCreateVolume.GetSize(): int64;
var
  tmpSize: int64;
  tmpULL: ULONGLONG;
  critSizeULL: ULONGLONG;
begin
  if ckSizeEntirePartitionDisk.checked then
    begin
    tmpULL := fmeSelectPartition.SelectedSize();

    // If CDB forms part of the volume, reduce as appropriate
    if CDBInVolFile then
      begin
      critSizeULL:= (CRITICAL_DATA_LENGTH div 8);
      tmpULL := tmpULL - critSizeULL;
      end;

    tmpSize := tmpULL;
    end
  else
    begin
    // Calculate the number of bytes...
    // Note: The in64(...) cast is REQUIRED, otherwise Delphi will calculate the
    //       value in 32 bits, and assign it to the 64 bit VolumeSize
    tmpSize := int64(seSize.Value) * 1024;

    if (cbSizeUnits.Items[cbSizeUnits.ItemIndex] = 'MB') then
      begin
      tmpSize := tmpSize * 1024;
      end;

    if (cbSizeUnits.Items[cbSizeUnits.ItemIndex] = 'GB') then
      begin
      tmpSize := tmpSize * 1024 * 1024;
      end;
    end;

  Result := tmpSize;
end;

function TfrmWizardCreateVolume.GetHashKernelDeviceName(): string;
var
  retval: string;
begin
  retval := '';

  if (cbHash.ItemIndex >= 0) then
    begin
    retval := hashKernelModeDriverNames[cbHash.ItemIndex];
    end;

  Result := retval;
end;

function TfrmWizardCreateVolume.GetHashGUID(): TGUID;
var
  strGUID: string;
begin
  // Just some dummy GUID in case none selected
  strGUID := DUMMY_GUID;

  if (cbHash.ItemIndex >= 0) then
    begin
    strGUID := hashGUIDs[cbHash.ItemIndex];
    end;

  Result := StringToGUID(strGUID);
end;

function TfrmWizardCreateVolume.GetCypherKernelDeviceName(): string;
var
  retval: string;
begin
  retval := '';

  if (cbCypher.ItemIndex >= 0) then
    begin
    retval := cypherKernelModeDriverNames[cbCypher.ItemIndex];
    end;

  Result := retval;
end;

function TfrmWizardCreateVolume.GetCypherGUID(): TGUID;
var
  strGUID: string;
begin
  // Just some dummy GUID in case none selected
  strGUID := DUMMY_GUID;

  if (cbCypher.ItemIndex >= 0) then
    begin
    strGUID := cypherGUIDs[cbCypher.ItemIndex];
    end;

  Result := StringToGUID(strGUID);
end;

function TfrmWizardCreateVolume.GetSectorIVGenMethod(): TFreeOTFESectorIVGenMethod;
var
  retVal: TFreeOTFESectorIVGenMethod;
begin
  retVal := foivgUnknown;

  if (cbSectorIVGenMethod.ItemIndex >= 0) then
    begin
    retVal := TFreeOTFESectorIVGenMethod(cbSectorIVGenMethod.Items.Objects[cbSectorIVGenMethod.ItemIndex]);
    end;

  Result := retVal;
end;

procedure TfrmWizardCreateVolume.SetSectorIVGenMethod(sectorIVGenMethod: TFreeOTFESectorIVGenMethod);
var
  i: integer;
  idx: integer;
begin
  idx := -1;

  // Locate the appropriate idx
  for i:=0 to (cbSectorIVGenMethod.Items.Count-1) do
    begin
    if (TFreeOTFESectorIVGenMethod(cbSectorIVGenMethod.Items.Objects[i]) = sectorIVGenMethod) then
      begin
      idx := i;
      break;
      end;
    end;

  cbSectorIVGenMethod.ItemIndex := idx;
end;

function TfrmWizardCreateVolume.GetUsePerVolumeIV(): boolean;
begin
  Result := ckUsePerVolumeIV.checked;
end;


function TfrmWizardCreateVolume.GetRandomData(): string;
begin
  Result := fCombinedRandomData;
end;

function TfrmWizardCreateVolume.GetPassword(): string;
begin
  Result := preUserKey1.Text;
end;

function TfrmWizardCreateVolume.GetMasterKeyLength(): integer;
var
  retval: integer;
begin
  retval := SelectedCypherKeySize();
  if (retval < 0) then
    begin
    retval := seMasterKeyLength.Value;
    end;

  Result := retval;
end;


procedure TfrmWizardCreateVolume.edByteOffsetChange(Sender: TObject);
begin
  CheckCurrentTabComplete();

end;

procedure TfrmWizardCreateVolume.SizeChanged(Sender: TObject);
begin
  CheckCurrentTabComplete();

end;

procedure TfrmWizardCreateVolume.pbBrowseGPGClick(Sender: TObject);
begin
  GPGOpenDialog.Filter     := FILE_FILTER_FLT_EXECUTABLES;
  GPGOpenDialog.DefaultExt := FILE_FILTER_DFLT_EXECUTABLES;

  SDUOpenSaveDialogSetup(GPGOpenDialog, lblGPGFilename.caption);
  if GPGOpenDialog.execute then
    begin
    lblGPGFilename.caption := GPGOpenDialog.Filename;
    end;

  CheckCurrentTabComplete();

end;

procedure TfrmWizardCreateVolume.MouseRNGByteGenerated(Sender: TObject;
  random: Byte);
begin
  // Note: This is correct; if it's *less than* CRITICAL_DATA_LEN, then store it
  if (CountMouseRNGData() < CRITICAL_DATA_LENGTH) then
    begin
    AddToMouseRNGData(random);
    end;

  CheckCurrentTabComplete();

end;

procedure TfrmWizardCreateVolume.PopulateHashes();
var
  tmpDisplayTitles: TStringList;
  i: integer;
  hashDetails: TFreeOTFEHash;
  hashAcceptable: boolean;
begin
  tmpDisplayTitles:= TStringList.Create();
  try
    if (OTFEFreeOTFE.GetHashList(tmpDisplayTitles, hashKernelModeDriverNames, hashGUIDs)) then
      begin
      // Strip out all hashes which have:
      //   length <= 0 or blocksize <= 0
      //  - they cannot be used to create new FreeOTFE volumes as they use
      // PBKDF2 (HMAC) to derive the critical data key; and PBKDF2 with HMAC
      // requires that the hash used has a defined length of greater than zero
      for i:=(tmpDisplayTitles.count-1) downto 0 do
        begin
        if not(OTFEFreeOTFE.GetSpecificHashDetails(hashKernelModeDriverNames[i], StringToGUID(hashGUIDs[i]), hashDetails)) then
          begin
          // Just warn user, and ignore...
          SDUMessageDlg('Unable to obtain hash details for '+tmpDisplayTitles[i], mtWarning, [mbOK], 0);
          hashAcceptable := FALSE;
          end
        else
          begin
          hashAcceptable := (hashDetails.Length > 0) and (hashDetails.BlockSize > 0); 
          end;

          
        // If the current hash algorithm is no use, don't add it to the list
        // offered to the user...
        if not(hashAcceptable) then
          begin
          tmpDisplayTitles.Delete(i);
          hashKernelModeDriverNames.Delete(i);
          hashGUIDs.Delete(i);
          end;

        end;

      // Populate the dropdown list offered to the user...
      cbHash.Items.Clear();
      cbHash.Items.AddStrings(tmpDisplayTitles);

      if (cbHash.Items.count = 0) then
        begin
        SDUMessageDlg('You do not appear to have any FreeOTFE hash drivers '+SDUCRLF+
                   'that can be used to create new FreeOTFE volumes installed '+SDUCRLF+
                   'and started.'+SDUCRLF+
                   SDUCRLF+
                   'If you have only just installed FreeOTFE, you may need to '+SDUCRLF+
                   'restart your computer.',
                   mtError,
                   [mbOK],
                   0);
        end;

      end
    else
      begin
      SDUMessageDlg('Unable to obtain list of hashes.'+SDUCRLF+
                 SDUCRLF+
                 'Please ensure that you have one or more FreeOTFE hash '+SDUCRLF+
                 'drivers installed and started.'+SDUCRLF+
                 SDUCRLF+
                 'If you have only just installed FreeOTFE, you may need to '+SDUCRLF+
                 'restart your computer.',
                 mtError,
                 [mbOK],
                 0);
      end;
  finally
    tmpDisplayTitles.Free();
  end;

end;

procedure TfrmWizardCreateVolume.PopulateCyphers();
var
  tmpDisplayTitles: TStringList;
begin
  tmpDisplayTitles:= TStringList.Create();
  try
    if (OTFEFreeOTFE.GetCypherList(tmpDisplayTitles, cypherKernelModeDriverNames, cypherGUIDs)) then
      begin
      cbCypher.Items.Clear();
      cbCypher.Items.AddStrings(tmpDisplayTitles);
      end
    else
      begin
      SDUMessageDlg('Unable to obtain list of cyphers.'+SDUCRLF+
                 SDUCRLF+
                 'Please ensure that you have one or more FreeOTFE cypher '+SDUCRLF+
                 'drivers installed and started.'+SDUCRLF+
                 SDUCRLF+
                 'If you have only just installed FreeOTFE, you may need to '+SDUCRLF+
                 'restart your computer.',
                 mtError,
                 [mbOK],
                 0);
      end;
  finally
    tmpDisplayTitles.Free();
  end;
  
end;

procedure TfrmWizardCreateVolume.PopulateSectorIVGenMethods();
var
  currMethod: TFreeOTFESectorIVGenMethod;
begin
  cbSectorIVGenMethod.Items.Clear();
  for currMethod:=low(TFreeOTFESectorIVGenMethod) to high(TFreeOTFESectorIVGenMethod) do
    begin
    // Skip "Unknown"
    if (currMethod <> foivgUnknown) then
      begin
      cbSectorIVGenMethod.Items.AddObject(FreeOTFESectorIVGenMethodTitle[currMethod], Pointer(ord(currMethod)));
      end;
    end;

end;

procedure TfrmWizardCreateVolume.FormCreate(Sender: TObject);
begin
  hashKernelModeDriverNames:= TStringList.Create();
  hashGUIDs:= TStringList.Create();
  cypherKernelModeDriverNames:= TStringList.Create();
  cypherGUIDs:= TStringList.Create();
  IVGenMethodIDs:= TStringList.Create();

  deviceList:= TStringList.Create();
  deviceTitle:= TStringList.Create();

  fCachedCypherKeysize := CYPHER_KEYSIZE_NOT_CACHED_FLAG_KEYSIZE;
  fCachedCypherBlocksize := CYPHER_BLOCKSIZE_NOT_CACHED_FLAG_BLOCKSIZE;
  fCachedCypherMode:= focmUnknown;

  // Start cryptlib, if possible, as early as we can to allow it as much time
  // as possible to poll entropy
  CanUseCryptlib := cryptlibLoad();

end;

procedure TfrmWizardCreateVolume.FormDestroy(Sender: TObject);
var
  i: integer;
begin
{$IFDEF FREEOTFE_DEBUG}
showmessage('destroying wizard');
{$ENDIF}
  hashKernelModeDriverNames.Free();
  hashGUIDs.Free();
  cypherKernelModeDriverNames.Free();
  cypherGUIDs.Free();
  IVGenMethodIDs.Free();

  deviceList.Free();
  deviceTitle.Free();

  // Shutdown cryptlib, if used
  if CanUseCryptlib then
    begin
    cryptlibUnload();
    CanUseCryptlib := FALSE;
    end;

  PurgeMouseRNGData();

  for i:=1 to length(fCombinedRandomData) do
    begin
    fCombinedRandomData[i] := char(i);
    end;

end;


procedure TfrmWizardCreateVolume.cbHashCypherIVGenChange(Sender: TObject);
begin
  // Cypher changed; clear any cached keysize
  fCachedCypherKeysize := CYPHER_KEYSIZE_NOT_CACHED_FLAG_KEYSIZE;
  // Cypher changed; clear any cached blocksize
  fCachedCypherBlocksize := CYPHER_BLOCKSIZE_NOT_CACHED_FLAG_BLOCKSIZE;
  // Cypher changed; clear any cached mode
  fCachedCypherMode:= focmUnknown;

  CheckCurrentTabComplete();

end;


procedure TfrmWizardCreateVolume.PopulateSummary();
var
  totalSize: int64;
  driveLetter: string;
  RNGs: string;
begin
  reSummary.Lines.Clear();

  if (IsPartition) then
    begin
    reSummary.Lines.Add('Partition: '+VolFilename);
    end
  else
    begin
    reSummary.Lines.Add('Filename: '+VolFilename);
    end;

  if (IsHidden) then
    begin
    reSummary.Lines.Add('Hidden volume starting at offset: '+inttostr(GetOffset()));
    end;

  if CDBInVolFile then
    begin
    totalSize := Size + int64(CRITICAL_DATA_LENGTH div 8);
    reSummary.Lines.Add('Volume size: '+SDUIntToStr(Size)+' + '+inttostr(CRITICAL_DATA_LENGTH div 8)+' (for CDB) = '+SDUIntToStr(totalSize)+' bytes');
    reSummary.Lines.Add('CDB stored: At start of volume file');
    end
  else
    begin
    reSummary.Lines.Add('Volume size: '+SDUIntToStr(Size)+' bytes');
    reSummary.Lines.Add('CDB stored: In separate keyfile');
    reSummary.Lines.Add('CDB keyfile: '+KeyFilename);
    end;

  reSummary.Lines.Add('Hash algorithm: '+cbHash.Items[cbHash.ItemIndex]);
  reSummary.Lines.Add('  [Hash driver: '+GetHashKernelDeviceName()+']');
  reSummary.Lines.Add('  [Hash GUID: '+GUIDToString(GetHashGUID())+']');

  reSummary.Lines.Add('Key iterations: '+inttostr(KeyIterations));


  if (SelectedCypherBlockSize() <= 0) then
    begin
    reSummary.Lines.Add('Sector IVs will not be used (cypher has zero or variable blocksize)');
    end
  else
    begin
    reSummary.Lines.Add('Cypher has fixed, defined blocksize; sector IVs will be used');
    reSummary.Lines.Add('Sector IV generation method: '+FreeOTFESectorIVGenMethodTitle[SectorIVGenMethod]);

    if (UsePerVolumeIV) then
      begin
      reSummary.Lines.Add('Sector IVs will be XORd with a per-volume IV before use');
      end
    else
      begin
      reSummary.Lines.Add('A per-volume IV will not be used');
      end;

    end;

  reSummary.Lines.Add('Cypher algorithm: '+cbCypher.Items[cbCypher.ItemIndex]);
  reSummary.Lines.Add('  [Cypher driver: '+GetCypherKernelDeviceName()+']');
  reSummary.Lines.Add('  [Cypher GUID: '+GUIDToString(GetCypherGUID())+']');

  reSummary.Lines.Add('Master key length: '+inttostr(MasterKeyLength)+' bits');

  RNGs := '';
  if ckRNGCryptoAPI.checked then
    begin
    if (RNGs = '') then
      begin
      RNGS := RNGs + ckRNGCryptoAPI.caption;
      end
    else
      begin
      RNGS := RNGs + ', ' + ckRNGCryptoAPI.caption;
      end;
    end;
  if ckRNGMouseMovement.checked then
    begin
    if (RNGs = '') then
      begin
      RNGS := RNGs + ckRNGMouseMovement.caption;
      end
    else
      begin
      RNGS := RNGs + ', ' + ckRNGMouseMovement.caption;
      end;
    end;
  if ckRNGcryptlib.checked then
    begin
    if (RNGs = '') then
      begin
      RNGS := RNGs + ckRNGcryptlib.caption;
      end
    else
      begin
      RNGS := RNGs + ', ' + ckRNGcryptlib.caption;
      end;
    end;
  if ckRNGGPG.checked then
    begin
    if (RNGs = '') then
      begin
      RNGS := RNGs + ckRNGGPG.caption;
      end
    else
      begin
      RNGS := RNGs + ', ' + ckRNGGPG.caption;
      end;
    end;
  reSummary.Lines.Add('RNG: '+RNGs);


  reSummary.Lines.Add('Password: <entered>');
  reSummary.Lines.Add('Salt length: '+inttostr(SaltLength)+' bits');
  
  driveLetter := RequestedDriveLetter;
  if (driveLetter = #0) then
    begin
    driveLetter := 'Use default';
    end
  else
    begin
    driveLetter := driveLetter + ':';
    end;
  reSummary.Lines.Add('Requested drive letter: '+driveLetter);

end;

function TfrmWizardCreateVolume.GetRNGSet(): TRNGSet;
var
  retval: TRNGSet;
begin
  retval := [];

  if ckRNGCryptoAPI.checked then
    begin
    retval := retval + [rngCryptoAPI];
    end;

  if ckRNGMouseMovement.checked then
    begin
    retval := retval + [rngMouseMovement];
    end;

  if ckRNGcryptlib.checked then
    begin
    retval := retval + [rngcryptlib];
    end;

  if ckRNGPKCS11.checked then
    begin
    retval := retval + [rngPKCS11];
    end;

  if ckRNGGPG.checked then
    begin
    retval := retval + [rngGPG];
    end;

  Result := retval;
end;

procedure TfrmWizardCreateVolume.pbFinishClick(Sender: TObject);
var
  allOK: boolean;
begin
  allOK := GenerateRandomData(
                              GetRNGSet(),
                              (CRITICAL_DATA_LENGTH div 8),
                              OTFEFreeOTFE.PKCS11Library,
                              PKCS11TokenListSelected(cbToken),
                              lblGPGFilename.Caption,
                              fCombinedRandomData
                             );


  // *All* information required to create the new volume acquired - so create
  // the new volume
  if (allOK) then
    begin
    if CreateNewVolume() then
      begin
      ModalResult := mrOK;
      end;
    end;

end;


function TfrmWizardCreateVolume.CreateNewVolume(): boolean;
var
  allOK: boolean;
  volumeDetails: TVolumeDetailsBlock;
  CDBMetaData: TCDBMetaData;
  saltBytes: string;
  randomPool: string;
  volumeFileSize: int64;
  cdbFile: string;
  cdbOffset: int64;
  userCancel: boolean;
  junkBool: boolean;
begin
  allOK := TRUE;

  // Create the volume file, if not a partition
  if (allOK) then
    begin
    // If the new volume is on a partition; we can skip creating a large file
    // on the localfilesystem
    if not(IsPartition) then
      begin
      // Create the volume file (if it doesn't already exist)
      if (not(FileExists(VolFilename))) then
        begin
        volumeFileSize := Size;
        // Add on the size of the CDB, if stored in volume file
        if (CDBInVolFile) then
          begin
          volumeFileSize := volumeFileSize + int64(CRITICAL_DATA_LENGTH div 8);
          end;

        allOK := SDUCreateLargeFile(VolFilename, volumeFileSize, TRUE, userCancel);
        // If there was a problem, and not a user cancel, warn user
        if (not(allOK)) then
          begin
          if (userCancel) then
            begin
            SDUMessageDlg(
                       'Volume creation canceled',
                       mtInformation,
                       [mbOK],
                       0
                      );
            end
          else
            begin
            SDUMessageDlg(
                       'Unable to create volume file; please ensure you have '+inttostr(volumeFileSize)+' bytes free on the relevant drive',
                       mtError,
                       [mbOK],
                       0
                      );
            end;
          end;  // if not(allOK) then
        end;  // if (not(FileExists(filename))) then
      end;  // if not(IsPartition) then

    end;  // if (allOK) then



  // Create separate CDB file, if needed
  if (allOK) then
    begin
    if not(CDBInVolFile) then
      begin
      allOK := SDUCreateLargeFile(KeyFilename, (CRITICAL_DATA_LENGTH div 8), FALSE, junkBool);
      if not(allOK) then
        begin
        SDUMessageDlg('Unable to create separate CDB keyfile.', mtError, [mbOK], 0);
        end;
      end;
    end;


  if (allOK) then
    begin
{$IFDEF FREEOTFE_DEBUG}
OTFEFreeOTFE.DebugMsg('Populating critical data structure...');
{$ENDIF}
    // Create the volume file header
    // Note: No need to populate CDBMetaData.MACAlgorithm or
    //       CDBMetaData.KDFAlgorithm as the function which writes the CDB out
    //       populates them automatically
    CDBMetaData.MACAlgorithm:= fomacUnknown;
    CDBMetaData.KDFAlgorithm:= fokdfUnknown;

    CDBMetaData.HashDriverKernelModeName   := HashKernelDeviceName;
    CDBMetaData.HashGUID                   := HashGUID;
    CDBMetaData.CypherDriverKernelModeName := CypherKernelDeviceName;
    CDBMetaData.CypherGUID                 := CypherGUID;
{$IFDEF FREEOTFE_DEBUG}
OTFEFreeOTFE.DebugMsg('Using hash driver: '+CDBMetaData.HashDriverKernelModeName);
OTFEFreeOTFE.DebugMsg('Using hash: '+GUIDToString(CDBMetaData.HashGUID));
OTFEFreeOTFE.DebugMsg('Using cypher driver: '+CDBMetaData.CypherDriverKernelModeName);
OTFEFreeOTFE.DebugMsg('Using cypher: '+GUIDToString(CDBMetaData.CypherGUID));
{$ENDIF}


    volumeDetails.CDBFormatID  := CDB_FORMAT_ID;
    volumeDetails.PartitionLen := Size;

    volumeDetails.VolumeFlags := 0;
{$IFDEF FREEOTFE_DEBUG}
OTFEFreeOTFE.DebugMsg('Volume flags: '+inttostr(volumeDetails.VolumeFlags)+' bits');
{$ENDIF}

    volumeDetails.SectorIVGenMethod := SectorIVGenMethod; 

    randomPool:= RandomData;

    volumeDetails.MasterKeyLength:= MasterKeyLength;
    // Grab 'n' bytes from the random pool to use as the master key
    volumeDetails.MasterKey := Copy(randomPool, 1, (volumeDetails.MasterKeyLength div 8));
    Delete(randomPool, 1, (volumeDetails.MasterKeyLength div 8));
{$IFDEF FREEOTFE_DEBUG}
OTFEFreeOTFE.DebugMsg('Master key length: '+inttostr(volumeDetails.MasterKeyLength)+' bits');
OTFEFreeOTFE.DebugMsg('Master key follows:');
OTFEFreeOTFE.DebugMsgBinary(volumeDetails.MasterKey);
{$ENDIF}

    // Grab 'n' bytes from the random pool to use as the volume IV
    // *Only* if the cypher's blocksize is a fixed, +ve number of bits
    volumeDetails.VolumeIVLength:= 0;
    if (SelectedCypherBlockSize() > 0) then
      begin
      if (UsePerVolumeIV) then
        begin
        volumeDetails.VolumeIVLength:= SelectedCypherBlockSize();
        end;
      end;
    volumeDetails.VolumeIV := Copy(randomPool, 1, (volumeDetails.VolumeIVLength div 8));
    Delete(randomPool, 1, (volumeDetails.VolumeIVLength div 8));
{$IFDEF FREEOTFE_DEBUG}
OTFEFreeOTFE.DebugMsg('Volume IV length: '+inttostr(volumeDetails.VolumeIVLength)+' bits');
OTFEFreeOTFE.DebugMsg('Volume IV follows:');
OTFEFreeOTFE.DebugMsgBinary(volumeDetails.VolumeIV);
{$ENDIF}


    volumeDetails.RequestedDriveLetter        := RequestedDriveLetter;

    // Grab 'n' bytes from the random pool to use as the salt
    saltBytes := Copy(randomPool, 1, (SaltLength div 8));
    Delete(randomPool, 1, (SaltLength div 8));

{$IFDEF FREEOTFE_DEBUG}
OTFEFreeOTFE.DebugMsg('About to write the critical data...');
OTFEFreeOTFE.DebugMsg('Using password: '+Password);
OTFEFreeOTFE.DebugMsg('Using salt... ');
OTFEFreeOTFE.DebugMsg('-- begin salt --');
OTFEFreeOTFE.DebugMsgBinary(saltBytes);
OTFEFreeOTFE.DebugMsg('-- end salt --');
{$ENDIF}

    // Determine filename and offset* within file of CDB
    cdbFile := VolFilename;
    cdbOffset := Offset;
    if not(CDBInVolFile) then
      begin
      // CDB stored in separate keyfile
      cdbFile := KeyFilename;
      cdbOffset := 0;
{$IFDEF FREEOTFE_DEBUG}
OTFEFreeOTFE.DebugMsg('CDB stored in separate keyfile: '+cdbFile);
{$ENDIF}
      end;

    // Write the header to the file, starting from the specified offset
    if not(OTFEFreeOTFE.WriteVolumeCriticalData(
                                   cdbFile,
                                   cdbOffset,
                                   Password,
                                   saltBytes,
                                   keyIterations,
                                   volumeDetails,
                                   CDBMetaData,
                                   randomPool
                                  )) then
      begin
      SDUMessageDlg(
                 'Unable to write critical data block.',
                 mtError,
                 [mbOK],
                 0
                );
      allOK := FALSE;
      end;  // if not(OTFEFreeOTFE.WriteVolumeCriticalData(

    end;  // if (allOK) then

  Result := allOK;
end;

procedure TfrmWizardCreateVolume.pbCancelClick(Sender: TObject);
begin
  ModalResult := mrCancel;

end;

procedure TfrmWizardCreateVolume.seMasterKeyLengthChange(Sender: TObject);
begin
  CheckCurrentTabComplete();

end;

procedure TfrmWizardCreateVolume.seMasterKeyLengthExit(Sender: TObject);
begin
  // Ensure master key length is a multiple of 8 bits
  if ((seMasterKeyLength.Value mod 8) <> 0) then
    begin
    SDUMessageDlg('The master key length must be a multiple of 8', mtWarning, [mbOK], 0);
    ActiveControl := seMasterKeyLength;
    end;

  CheckCurrentTabComplete();
end;


// Returns the keysize for the user's selected cyppher, as returned by the
// driver
// Returns CYPHER_KEYSIZE_NOT_CACHED_FLAG_KEYSIZE on error
function TfrmWizardCreateVolume.SelectedCypherKeySize(): integer;
var
  cypherDetails: TFreeOTFECypher_v3;
  retval: integer;
begin
  retval := CYPHER_KEYSIZE_NOT_CACHED_FLAG_KEYSIZE;
  // Determine the keysize of the cypher selected

  // If we have it cached alredy, use it
  if (fCachedCypherKeysize <> CYPHER_KEYSIZE_NOT_CACHED_FLAG_KEYSIZE) then
    begin
    retval := fCachedCypherKeysize;
    end
  else
    if not(OTFEFreeOTFE.GetSpecificCypherDetails(
                                                CypherKernelDeviceName,
                                                CypherGUID,
                                                cypherDetails
                                               )) then
      begin
      SDUMessageDlg('Unable to determine the keysize for your selected cypher.', mtError, [mbOK], 0);
      end
    else
      begin
      // Cache keysize and return...
      fCachedCypherKeysize := cypherDetails.KeySizeRequired;
      retval := fCachedCypherKeysize;
      end;

  Result := retval;

end;

// Returns the blocksize for the user's selected cyppher, as returned by the
// driver
// Returns CYPHER_BLOCKSIZE_NOT_CACHED_FLAG_BLOCKSIZE on error
function TfrmWizardCreateVolume.SelectedCypherBlockSize(): integer;
var
  cypherDetails: TFreeOTFECypher_v3;
  retval: integer;
begin
  retval := CYPHER_BLOCKSIZE_NOT_CACHED_FLAG_BLOCKSIZE;
  // Determine the blocksize of the cypher selected

  // If we have it cached alredy, use it
  if (fCachedCypherBlocksize <> CYPHER_BLOCKSIZE_NOT_CACHED_FLAG_BLOCKSIZE) then
    begin
    retval := fCachedCypherBlocksize;
    end
  else
    if not(OTFEFreeOTFE.GetSpecificCypherDetails(
                                                CypherKernelDeviceName,
                                                CypherGUID,
                                                cypherDetails
                                               )) then
      begin
      SDUMessageDlg('Unable to determine the blocksize for your selected cypher.', mtError, [mbOK], 0);
      end
    else
      begin
      // Cache blocksize and return...
      fCachedCypherBlocksize := cypherDetails.BlockSize;
      retval := fCachedCypherBlocksize;
      end;

  Result := retval;

end;


// Returns the cypher mode for the user's selected cypher, as returned by
// the driver
function TfrmWizardCreateVolume.SelectedCypherMode(): TFreeOTFECypherMode;
var
  cypherDetails: TFreeOTFECypher_v3;
  retval: TFreeOTFECypherMode;
begin
  retval:= focmUnknown;

  // If we have it cached alredy, use it
  if (fCachedCypherMode <> focmUnknown) then
    begin
    retval := fCachedCypherMode;
    end
  else
    if not(OTFEFreeOTFE.GetSpecificCypherDetails(
                                                CypherKernelDeviceName,
                                                CypherGUID,
                                                cypherDetails
                                               )) then
      begin
      SDUMessageDlg('Unable to determine the cypher mode for your selected cypher.', mtError, [mbOK], 0);
      end
    else
      begin
      // Cache blocksize and return...
      fCachedCypherMode := cypherDetails.Mode;
      retval := fCachedCypherMode;
      end;

  Result := retval;

end;


procedure TfrmWizardCreateVolume.pbHashInfoClick(Sender: TObject);
var
  deviceName: string;
  GUID: TGUID;
begin
  deviceName := GetHashKernelDeviceName();
  GUID := GetHashGUID();
  TOTFEFreeOTFE(OTFEFreeOTFE).ShowHashDetailsDlg(deviceName, GUID);

end;


procedure TfrmWizardCreateVolume.pbCypherInfoClick(Sender: TObject);
var
  deviceName: string;
  GUID: TGUID;
begin
  deviceName := GetCypherKernelDeviceName();
  GUID := GetCypherGUID();
  TOTFEFreeOTFE(OTFEFreeOTFE).ShowCypherDetailsDlg(deviceName, GUID);

end;


procedure TfrmWizardCreateVolume.rbCDBLocationClick(Sender: TObject);
begin
  CheckCurrentTabComplete();

end;

procedure TfrmWizardCreateVolume.ckPartitionHiddenClick(Sender: TObject);
begin
  se64ByteOffset.Value := 0;
  if (ckPartitionHidden.checked) then
    begin
    // Force the user to reenter their offset, by marking the offset tabsheet
    // as incomplete
    tsOffset.Tag := 0;
    end
  else
    begin
    // New file; critical data automatically stored at the start of the file;
    // zero offset
    tsOffset.Tag := 1;
    end;

  CheckCurrentTabComplete();

end;

procedure TfrmWizardCreateVolume.rgFileOrPartitionClick(Sender: TObject);
begin
  // Size tab must be marked as incomplete if the user switched to partition,
  // just in case the user previously entered a size value that's now too big
  if IsPartition then
    begin
    tsSize.Tag := 0;
    end;

  CheckCurrentTabComplete();
end;

procedure TfrmWizardCreateVolume.se64ByteOffsetChange(Sender: TObject);
begin
  CheckCurrentTabComplete();
end;

procedure TfrmWizardCreateVolume.seSizeChange(Sender: TObject);
begin
  CheckCurrentTabComplete();
end;

procedure TfrmWizardCreateVolume.seSizeExit(Sender: TObject);
begin
  // Warn user if volume size smaller than PDA version min
  if (Size < (MIN_PDA_VOLUME_SIZE * BYTES_IN_MEGABYTE)) then
    begin
    SDUMessageDlg(
               'Please note: If you would like your volume to be compatible with the PDA version of FreeOTFE, please specify a volume size greater than '+inttostr(MIN_PDA_VOLUME_SIZE)+' MB',
               mtWarning,
               [mbOK],
               0
              );
    end;

  CheckCurrentTabComplete();
end;

procedure TfrmWizardCreateVolume.PopulatePKCS11Tokens();
begin
  FPKCS11TokensAvailable := (PKCS11PopulateTokenList(
                                                     OTFEFreeOTFE.PKCS11Library,
                                                     cbToken
                                                    ) > 0);
end;

procedure TfrmWizardCreateVolume.pbRefreshClick(Sender: TObject);
begin
  PopulatePKCS11Tokens();
end;

procedure TfrmWizardCreateVolume.fmeSelectPartitionChanged(Sender: TObject);
begin
  se64ByteOffset.Value := 0;

  lblPartitionDiskSize.Caption := '(Approx: '+SDUFormatAsBytesUnits(fmeSelectPartition.SelectedSize())+')';

  // Size tab must be marked as incomplete
  tsSize.Tag := 0;

  CheckCurrentTabComplete();

end;


function TfrmWizardCreateVolume.GetCDBInVolFile(): boolean;
begin
  Result := (Trim(KeyFilename) = '');
end;


END.


