unit SDUFilenameLabel;
// Description: Filename Label
// By Sarah Dean
// Email: sdean12@sdean12.org
// WWW:   http://www.SDean12.org/
//
// -----------------------------------------------------------------------------
//
// Set "Caption" to be the filename to be shown; if the label isn't wide enough
// to display the full filename, it'll have some of it's text replaced
// with "..."
//
// -----------------------------------------------------------------------------


interface

uses
  stdctrls, Classes, Graphics, Messages, Controls,
  Windows, ShellAPI;

type
  TSDUFilenameLabel = class(TLabel)
  protected
    function GetLabelText(): string; override;
  end;

procedure Register;

implementation

uses
{$WARN UNIT_PLATFORM OFF}
  FileCtrl;

procedure Register;
begin
  RegisterComponents('SDeanUtils', [TSDUFilenameLabel]);
end;

function TSDUFilenameLabel.GetLabelText(): string;
begin
  Result := MinimizeName(Caption, Canvas, Width);
end;


END.


